program Identify_bound
  !Input fatten_bound and it will track the inner and outer boundaries  Jesse Lomask 10/04/05
  !Store the x, y, norm, distance
  use sep
  use lint2
  use warp_mod
  use sorting_mod
  use paint_mod3d
  use pick_mod

  implicit none

  integer				::nt, nx, ny, non_zero_mask,istatus,bnd_index
  integer				::it,ix,iy,ir,iq,iz,ip,it_shft,ix_shft,iy_shft
  integer                               ::radius,irx,irt
  integer                               ::diag_count, adj_count, ix_diag, it_diag, ix_new, it_new
  integer                               ::ix_old, it_old,pick_count,which_bound
  real::o1,o2,o3,d1,d2,d3,maxdat,mindat,rangedat,cutoff,dist
  real, pointer, dimension(:,:)	        ::horizon_out
  real, pointer, dimension(:,:,:)	::mask_out
  real, pointer, dimension(:,:,:)	::data, norm_d,mask_in,inner_bnd,outer_bnd
  real                                  ::mask_val1,mask_val2
!!$  real, dimension(:,:,:)                ::box_grid,box_grid_colx,box_grid_coly,box_grid_row,box_grid_bnds


  ! HOOK UP SEP PARAMETER INPUT FACILITY
  call sep_init(SOURCE)

!!$  ! INPUT PARAMETERS
  call from_history("n1",nt); call from_history("n2",nx);
  call from_history("n3",ny);
  call from_history("o1",o1); call from_history("o2",o2); call from_history("o3",o3);
  call from_history("d1",d1); call from_history("d2",d2); call from_history("d3",d3);

  call from_param("cutoff",cutoff,0.)
  call from_param("which_bound",which_bound,0)
  ! ALLOCATE INPUT DATA AND MASK
  allocate(data(nt,nx,ny),mask_in(nt,nx,ny),mask_out(nt,nx,ny),horizon_out(nt*nx*ny,2))

  ! READ INPUT DATA
  call sep_read(data)

  ! READ IN INPUT MASK
  mask_in=1.
  if (exist_file("mask_in")) call sreed("mask_in", mask_in, 4*nt*nx*ny) 

  write(0,*) maxval(data),minval(data),nt,nx,ny

  write(0,*) 'making mask'
  mask_out=0.
  !  cutoff=.00065
  pick_count=0


  ! SCAN OVER CUBE
  do iy=1,ny
     do ix=1,nx
        do it=1,nt
           ! SCAN FOR SEED POINT, A BOUND HAS ONE OF ITS FOUR ADJACENT SIDES TOUCHING OUTSIDE OF THE BOUNDARY
           if (isbound3d(data,mask_in,it,nt,ix,nx,iy,ny,which_bound)) then
mask_out(it,ix,iy)=which_bound
           end if

        end do
     end do
  end do

!!$  call to_history("n1",pick_count); call to_history("n2",2) 
!!$  call to_history("n3",1)
!!$  call to_history("d1",1); call to_history("d2",1 )
!!$  call to_history("d3",1 )
!!$  call to_history("o1",0.); call to_history("o2",0.)
!!$  call to_history("o3",0.)
!!$  call to_history("esize",4)
!!$  call sep_write(horizon_out(1:pick_count,1:))


  call to_history("n1",nt) ; call to_history("n2",nx) 
  call to_history("n3",ny)
  call to_history("d1",d1); call to_history("d2",d2)
  call to_history("d3",d3)
  call to_history("o1",o1); call to_history("o2",o2)
  call to_history("o3",o3)
  call to_history("esize",4)
  call sep_write(mask_out)




 
end program Identify_bound

