program Make_zoom_mask
  !

  use sep
  implicit none

  integer :: nt, nx,ny,ix,it,width
  real:: dt,dx,dy,t0,x0,y0,cutoff
  real,  dimension(:,:)	,allocatable                  ::mask_out,input,output

  write(0,*) 'after inits'
  !! hook up sep parameter input facility
  call sep_init(SOURCE)


  call from_history("n1",nt); call from_history("n2",nx);
  call from_history("n3",ny);
  write(0,*) 'n1/n2',nt,nx
  ny=1;dt=1.;dx=1.;dy=1.;t0=0.;x0=0.;y0=0.

  call to_history( "n1", nt);  call to_history( "n2", nx);!  call to_history( "n3", 1)
  call to_history( "d1", 1);  call to_history( "d2", 1); ! call to_history( "d3", 1)
  call to_history( "o1", t0);  call to_history( "o2", x0);!  call to_history( "o3", y0)
  call to_history("esize",4);
call from_param("width",width,20)
  call from_param("cutoff",cutoff,0.)

  allocate(input(nt,nx),output(nt,nx),mask_out(nt,nx)) 
  write(0,*) 'after allocations'
  call sep_read(input)
  write(0,*) 'read in data'
!!$
output=0.
  do ix=1,nx
     do it=1,nt
        !write(0,*) ix,it,nx,nt
        if( (input(it,ix)>cutoff)) then
           output(it,ix)=1.
        else
           output(it,ix)=0.
        end if

        !write(0,*) horiz(ix,1),horiz(ix,2)
     end do
  end do



  mask_out=0.
  do ix=1,nx
     do it=2,nt-1
        !write(0,*) ix,it,nx,nt
     !   if (abs(input(it-1,ix)-input(it,ix))>.1) horiz(ix,1)=it
     !   if (abs(input(it+1,ix)-input(it,ix))>.1) horiz(ix,2)=it

 !   if (abs(input(it-1,ix)-input(it,ix))>.1) mask_out(max(it-width,1):min(it+width,nx),ix)=1.
  
  if (output(it-1,ix)/=output(it,ix)) mask_out(max(it-width,1):min(it+width,nx),ix)=1.
 !       if (output(it+1,ix)/=output(it,ix)) horiz(ix,2)=it
        !write(0,*) horiz(ix,1),horiz(ix,2)
     end do
  end do

  write(0,*) 'about to writ out'
  call srite("out",mask_out,4*nt*nx)



end program Make_zoom_mask
