function [norm]=fitplane(data) 


% function to fit a plane
sample_num=length(data) ;
%data=zeros(5,3)  %  t,x,y

% test data
% data(1,1)=10 ;
% data(1,2)=1  ;
% data(1,3)=1  ;
% data(2,1)=11  ;
% data(2,2)=2  ;
% data(2,3)=1  ;
% data(3,1)=12  ;
% data(3,2)=3   ;
% data(3,3)=1  ;
% data(4,1)=13  ;
% data(4,2)=4  ;
% data(4,3)=1  ;
% data(5,1)=11  ;
% data(5,2)=2 ;
% data(5,3)=5  ;



% CALCULATE THE CENTROID
centroid(1)=mean(data(:,1)) ;  
centroid(2)=mean(data(:,2)) ; 
centroid(3)=mean(data(:,3)) ;   

% centroid
% plot3(data(:,1),data(:,2),data(:,3),'r.');
% hold on
% plot3(centroid(1),centroid(2),centroid(3),'k.');

% define M matrix
%M=[data(1,1)-centroid(1)     data(1,2)-centroid(2)     data(1,3)-centoid(3)    ;
%   data(2,1)-centroid(1)     data(2,2)-centroid(2)     data(2,3)-centoid(3)    ;
M=zeros(sample_num,3);
for iq=1:sample_num

    M(iq,1)=data(iq,1)-centroid(1)   ;  
    M(iq,2)=data(iq,2)-centroid(2)   ;
    M(iq,3)=data(iq,3)-centroid(3)    ;
end

%[U,S,V]=svds(M,3,0)
[U,S,V]=svd(M);
norm=V(:,3);
