module sample_mod_3d
!!! 
  use lint2
  use warp_mod
  use paint_mod
  use lint
  use sep

contains


  subroutine sample_model3d(nt,nx,ny,mem_alloc,sample_scale,max_dist,amp_thresh,zero_tol,t1,x1,y1,full_image,full_image_1d,sparse_mat,sparse_mat_index,col_in_row,look_up_image,val_list,val_cnt,mask_in,outer_bnd,outer_bnd_tracker,inner_bnd,inner_bnd_tracker,first_attribute,attr_coef,ignore_wrapping)


    real,dimension(:)	                ::val_list
    integer                             ::val_cnt,sample_num,iz
    integer                             ::sparse_mat_index,mem_alloc,irow_mat,icol_mat
    integer                             ::nodes,path_t,path_x,path_y,node_counter
    integer                             ::t_shift_int,x_shift_int,y_shift_int
    real,dimension(:)                 	::full_image_1d
    real, pointer, dimension(:,:)       ::sparse_mat,path_txy,new_path_txy,path_xy
    real,dimension(:),allocatable	::path_dd,in_plane_vec
    real, dimension(:,:,:)                ::look_up_image,first_attribute
    real                                ::t1_rl,t2_rl,x1_rl,y1_rl,x2_rl,y2_rl,iz_rl,sample_scale
    real                                ::x_shift,y_shift,rand_dip,rand_dir,rand_azi,rand_dist,dist,pi_var,dist2,amp_thresh
    real                                ::attr_coef,in_plane_dist

    integer                             ::it,ix,iy,boundary_index,iq
    integer                             :: nx,ny,nt,max_dist,t1,col1,rand_jump_int
    integer                             ::t2_raw,x2_raw,y2_raw,delta_t2,delta_x2,delta_y2
    integer                             ::t2,x2,y2,too_far,dumbtest,found1
    integer                             ::col_in_row,x1,y1
    integer                             ::n_t,n_x,n_y,outer_shft1,outer_bnd_sum,inner_shft1
    integer                             ::inner_bnd_sum,step,n_t2,n_x2,n_y2,irow
    integer                             ::outer_bnd_n1, inner_bnd_n1,ignore_wrapping
  
    real                                ::rand_jump,vec_length,norm_length
    real                                ::dt,dx,dy,norm_dist1,xt_dist,yt_dist 
    real                                ::t2_2bnd,x2_2bnd,y2_2bnd
    real,dimension(:),allocatable	::norm_at_bnd,norm_at_new_bnd  !,t2_2bnd
    real,dimension(:),allocatable       ::xt_basis,xt_basis_2,yt_basis,yt_basis_2
    real,dimension(:),allocatable       ::basis_at_bnd,basis_at_new_bnd,point2_2bnd
    real,dimension(:),allocatable       ::vec_at_bnd,vec_at_new_bnd
    real,pointer, dimension(:,:,:)      ::full_image
    real,dimension(:,:)                 ::inner_bnd_tracker,outer_bnd_tracker  
    real, dimension(:,:,:)                ::mask_in
    real, dimension(:,:,:)                ::inner_bnd,outer_bnd

!!$write(0,*) mask_in(12,116,62)
!!$write(0,*) nt,nx,ny
!!$stop

!!$do it=1,nt
!!$do ix=1,nx
!!$do iy=1,ny
!!$!if (mask_in(it,ix,iy)==0.or. mask_in(it,ix,iy)==1.or.mask_in(it,ix,iy)==2)  then
!!$if (mask_in(it,ix,iy)>1..and.mask_in(it,ix,iy)<1.1)then
!!$!else
!!$write(0,*) mask_in(it,ix,iy), it,ix,iy
!!$end if
!!$end do
!!$end do
!!$end do
!!$write(0,*) 'stopping'
!!$stop

!!$
!!$  call to_history("n1",nt,"test.H"); call to_history("n2",nx,"test.H") 
!!$  call to_history("n3",ny,"test.H")
!!$ 
!!$  call sep_write(mask_in,"test.H")
!!$ stop


  !       write(0,*) 'into sample subroutine'
    pi_var=acos(-1.)
!!$    y1=1 ! DELETE ME !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    t1_rl=real(t1)
    x1_rl=real(x1)
    y1_rl=real(y1)

    ! call look_up_wt(look_up_tab,t1,col1,irow_mat)

    outer_bnd_n1=size(outer_bnd_tracker(1:,1))
    inner_bnd_n1=size(inner_bnd_tracker(1:,1))
!!$write(0,*) 'outer_bnd_n1',outer_bnd_n1
!!$write(0,*) 'inner_bnd_n1',inner_bnd_n1
    ! CONVENTIONS outer_bnd_tracker AND inner_bnd_tracker CONTAIN THE BASIS VECTORS
    ! *_bnd_tracker(1:3) ==> the norm 
    ! *_bnd_tracker(4:6) ==> the tangent in x direction 
    ! *_bnd_tracker(7:9) ==> the tangent in y direction

    ! RENORMALIZE BASIS VECTORS
!!$    do iq=1,outer_bnd_n1
!!$       outer_bnd_tracker(iq,3:4)=outer_bnd_tracker(iq,3:4)/((outer_bnd_tracker(iq,3)**2+outer_bnd_tracker(iq,4)**2)**.5)
!!$       outer_bnd_tracker(iq,5:6)=outer_bnd_tracker(iq,5:6)/((outer_bnd_tracker(iq,5)**2+outer_bnd_tracker(iq,6)**2)**.5)  
!!$    end do
!!$    do iq=1,inner_bnd_n1
!!$       inner_bnd_tracker(iq,3:4)=inner_bnd_tracker(iq,3:4)/((inner_bnd_tracker(iq,3)**2+inner_bnd_tracker(iq,4)**2)**.5)
!!$       inner_bnd_tracker(iq,5:6)=inner_bnd_tracker(iq,5:6)/((inner_bnd_tracker(iq,5)**2+inner_bnd_tracker(iq,6)**2)**.5)  
!!$    end do

    allocate(norm_at_bnd(3),norm_at_new_bnd(3)) !,t2_2bnd(3))
    allocate(xt_basis(3),xt_basis_2(3),yt_basis(3),yt_basis_2(3))
    allocate(basis_at_bnd(9),basis_at_new_bnd(9))
    allocate(vec_at_bnd(3),vec_at_new_bnd(3),in_plane_vec(3))

    allocate(point2_2bnd(3))
    !write(0,*) 'after allocations'



    ! DRAW RANDOM BOUNDARY SHIFTS
    ! JUMP RANDOM SHIFTS WHEN ABOVE OR BELOW MASK BOUNDARY
!!$    call random_number(rand_jump)
!!$    outer_shft1=nint(rand_jump*real(outer_bnd_n1-1)+1)   
!!$    inner_shft1=nint(rand_jump*real(inner_bnd_n1-1)+1)





    ! CALCULATE NUMBER OF SAMPLES
    n_sam=nint(sample_scale*(3.*pi_var*real(max_dist))) 
    !write(0,*) 'nsam'
    !stop


    loop_n_times: do srch=1,n_sam

       ! KEEP TRACK OF HOW MANY PIXELS (NODES)
       node_counter=1

       ! DRAW RANDOM NUMBERS  ==> DISTANCE, AZIMUTH
       ! DRAW RAND DIRECTION
       call random_number (rand_dip)
       rand_dip=rand_dip*2.*pi_var ! assign angle
       call random_number (rand_azi)
       rand_azi=rand_azi*2.*pi_var ! assign angle
!!$       rand_azi=0. ! DELETE ME !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
       ! DRAW RAND DISTANCE
       call random_number(rand_dist)
       rand_dist=(max_dist-1)*rand_dist+1


       ! DRAW RANDOM BOUNDARY SHIFTS
       ! JUMP RANDOM SHIFTS WHEN ABOVE OR BELOW MASK BOUNDARY
       call random_number(rand_jump)
       outer_shft1=nint(rand_jump*real(outer_bnd_n1-1)+1)   
       inner_shft1=nint(rand_jump*real(inner_bnd_n1-1)+1)


       ! CALCULATE SHIFTS FROM SPHERICAL COORDINATES
       t_shift=rand_dist*sin(rand_dip)
       x_shift=rand_dist*cos(rand_dip)*cos(rand_azi)
       y_shift=rand_dist*cos(rand_dip)*sin(rand_azi)


!!$       call random_number (rand_dir)! DELETE ME !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!$       rand_dir=rand_dir*2.*pi_var ! assign angle! DELETE ME !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!$       t_shift=rand_dist*cos(rand_dir) ! DELETE ME !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!$       x_shift=rand_dist*sin(rand_dir) ! DELETE ME !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!$       y_shift=0. ! DELETE ME !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

       t_shift_int=nint(t_shift)
       x_shift_int=nint(x_shift)
       y_shift_int=nint(y_shift)
       !write(0,*) t_shift_int ,x_shift_int, y_shift_int
       ! CALCULATE NEW POINT
       t2=t1+t_shift_int
       x2=x1+x_shift_int
       y2=y1+y_shift_int

!!$       y2=1 ! DELETE ME !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
       t2_rl=real(t2)
       x2_rl=real(x2)
       y2_rl=real(y2)


       dist=sqrt((t1_rl-t2_rl)**2+(x1_rl-x2_rl)**2+(y1_rl-y2_rl)**2)


!!$       if (t1==nt.and.x1==1.) then
!!$          write(0,*) t1,x1,t2,x2
!!$          write(0,*) 'dist',dist
!!$
!!$       end if
       ! MAKE SURE THE NEW POINT IS IN THE DATA CUBE
       !    within_bnds:  if (t2>=1.and.t2<=nt.and.col2>=1.and.col2<=nx ) then


       !          write(0,*) 'here1'
       !   call look_up_wt(look_up_tab,t2,col2,icol_mat)    
       !         write(0,*) 'here2'

!!$          ! MAKE SURE THIS NEW POINT HAS NOT ALREADY BEEN TESTED WITH THIS BASE POINT
!!$          isnew: if (IsNew(val_list,val_cnt,real(icol_mat))) then
!!$             val_cnt=val_cnt+1 
!!$             val_list(val_cnt)=real(icol_mat) ! if new point, add it to the list


       ! START STEPPING TOWARDS THE NEW POINT, KEEPING TRACK OF X,Y'S FOR BILINEAR INTERPOLATION AND ALSO CHECK TO SEE IF A BOUNDARY IS CROSSED

       sample_num=dist ! round down the distance(dist) to get the number of samples between points
       if (dist-sample_num<=.5) sample_num=sample_num-1 ! drop the last sample if it is too close to the end
       nodes=sample_num+2 ! total number of nodes including end points
!!$       if (t1==nt.and.x1==1.) then
!!$          write(0,*) 'sample_num',sample_num
!!$          write(0,*) 'nodes',nodes
!!$       end if
       !write(0,*) 'here1'
       allocate(path_txy(nodes,3))
       !write(0,*) 'here2',nodes

       path_txy(1,1)=t1_rl; path_txy(1,2)=x1_rl; path_txy(1,3)=y1_rl

       n_t=t1  ! ASSIGN LOCATIONS FOR BOUNDARY EXTRACTION
       n_x=x1
       n_y=y1

!if (nodes==2) node_counter=2

       !         write(0,*) 'nodes at beginning',nodes
       ! ASSIGN XY PAIRS TO EACH SAMPLE
       fillpath: do iz=2,nodes
!write(0,*) iz,nodes
          !write(0,*) 'here 2ba'
          iz_rl=real(iz)
          !       path_xy(iz,1)=((t2_rl-t1_rl)/dist)*(iz_rl-1)+t1_rl
          !       path_xy(iz,2)=((col2_rl-col1_rl)/dist)*(iz_rl-1)+col1_rl
          path_txy(iz,1)=((t2_rl-t1_rl)/(nodes-1))*(iz_rl-1.)+t1_rl
          path_txy(iz,2)=((x2_rl-x1_rl)/(nodes-1))*(iz_rl-1.)+x1_rl
          path_txy(iz,3)=((y2_rl-y1_rl)/(nodes-1))*(iz_rl-1.)+y1_rl
          ! write(0,*) 'path_txy(iz,3)',path_txy(iz,3)
          path_t=nint(path_txy(iz,1)) ; path_x=nint(path_txy(iz,2)) ; path_y=nint(path_txy(iz,3))

          !write(0,*) 'here 2bb',path_t,nt,path_x,nx,path_y,ny

!!$          if (t1==nt.and.x1==1.) then
!!$             write(0,*) 'iz',iz
!!$             write(0,*) path_txy(iz,1),path_txy(iz,2),path_txy(iz,3)
!!$             write(0,*) 'path_t,path_x,path_y',path_t,path_x,path_y
!!$          end if

          within_bnds:  if (path_txy(iz,1)>=1.and.path_txy(iz,1)<=nt.and.path_txy(iz,2)>=1.and.path_txy(iz,2)<=nx.and.path_txy(iz,3)>=1.and.path_txy(iz,3)<=ny ) then



             !write(0,*) path_row,path_col
             !write(0,*) 'here 2b'
             ! CHECK TO SEE IF BOUNDARY IS CROSSED
             ! IF CROSSES OUTER BOUNDARY
             out_of_mask: if (nint(mask_in(path_t,path_x,path_y))==0) then
                !             write(0,*) 'mask==0'
                !  stop
                if (ignore_wrapping==1.) then
                   sample_num=iz-2
                   t2=n_t ;x2=n_x ; y2=n_y
                   cycle loop_n_times !
                   ! exit fillpath !
                end if

                !            write(0,*) 'here2a'
                ! GRAB NEAREST BOUNDARY POINT
                if (outer_bnd(n_t,n_x,n_y)/=0) then
                   boundary_index=nint(outer_bnd(n_t,n_x,n_y))
                elseif(outer_bnd(n_t+1,n_x,n_y)/=0.and.n_t+1<=nt) then
                   boundary_index=nint(outer_bnd(n_t+1,n_x,n_y))
                elseif(outer_bnd(n_t-1,n_x,n_y)/=0.and.n_t-1>=1) then
                   boundary_index=nint(outer_bnd(n_t-1,n_x, n_y))
                elseif(outer_bnd(n_t,n_x+1,n_y)/=0.and.n_x+1<=nx) then
                   boundary_index=nint(outer_bnd(n_t,n_x+1,n_y))
                elseif(outer_bnd(n_t,n_x-1,n_y)/=0.and.n_x-1>=1) then
                   boundary_index=nint(outer_bnd(n_t,n_x-1,n_y))
                elseif(outer_bnd(n_t,n_x,n_y+1)/=0.and.n_y+1<=ny) then
                   boundary_index=nint(outer_bnd(n_t,n_x,n_y+1))
                elseif(outer_bnd(n_t,n_x,n_y-1)/=0.and.n_y-1>=1) then
                   boundary_index=nint(outer_bnd(n_t,n_x,n_y-1))
                else
                   write(0,*) 'did not find outer boundary',n_t,n_x,n_y,outer_bnd(n_t,n_x,n_y)
                 ! stop
                   ! grab another random point  !!! POSSIBLY DELETE
                   sample_num=iz-2              !!! POSSIBLY DELETE
                   t2=n_t ; x2=n_x ; y2=n_y     !!! POSSIBLY DELETE
                   cycle loop_n_times           !!! POSSIBLY DELETE


                end if

                if (boundary_index<1.or.boundary_index>outer_bnd_n1) then
                   write(0,*) 'boundary_index is strange',boundary_index
                   stop
                end if

                ! TAKE NORM AND POSITION VECTOR AT NEW BOUNDARY POINT
                !vec_at_new_bnd(1:2)=outer_bnd_tracker(outer_shft1,1:3) 
                t2_new_bnd=outer_bnd_tracker(outer_shft1,1) ! NEW BOUNDARY POINT
                x2_new_bnd=outer_bnd_tracker(outer_shft1,2) ! NEW BOUNDARY POINT
                y2_new_bnd=outer_bnd_tracker(outer_shft1,3) ! NEW BOUNDARY POINT
                t2_new_bnd_rl=real(t2_new_bnd) ; x2_new_bnd_rl=real(x2_new_bnd); y2_new_bnd_rl=real(y2_new_bnd)

                vec_at_bnd=outer_bnd_tracker(boundary_index,1:3)
                vec_at_new_bnd=outer_bnd_tracker(outer_shft1,1:3)
                norm_at_bnd=outer_bnd_tracker(boundary_index,4:6)
                norm_at_new_bnd=outer_bnd_tracker(outer_shft1,4:6)
!!$                basis_at_bnd =outer_bnd_tracker(boundary_index,1:9)
!!$                basis_at_new_bnd=outer_bnd_tracker(outer_shft1,1:9)

                ! VECTOR FROM BOUNDARY TO NEW POINT BEFORE SHIFT
                t2_2bnd=t2-n_t
                x2_2bnd=x2-n_x
                y2_2bnd=y2-n_y
                point2_2bnd(1)=t2_2bnd ; point2_2bnd(2)=x2_2bnd ; point2_2bnd(3)=y2_2bnd

                found1=1

                ! PROJECT ONTO BASIS AS FIRST POINT
                norm_dist   =1.*dot_product(point2_2bnd,norm_at_bnd)
                in_plane_vec=point2_2bnd-norm_dist*norm_at_bnd
                !         norm_dist   =1.*dot_product(point2_2bnd,basis_at_bnd(1:3))
                !         x_dist      =1.*dot_product(point2_2bnd,basis_at_bnd(4:6))
                !         y_dist      =1.*dot_product(point2_2bnd,basis_at_bnd(7:9))

                ! PROJECT ON NEW BASIS VECTORS TO GET NEW POINT
!!$                t2_new=nint(vec_at_new_bnd(1)-norm_dist*basis_at_new_bnd(1)-x_dist*basis_at_new_bnd(4)-y_dist*basis_at_new_bnd(7))
!!$                x2_new=nint(vec_at_new_bnd(2)-norm_dist*basis_at_new_bnd(2)-x_dist*basis_at_new_bnd(5)-y_dist*basis_at_new_bnd(8))
!!$                y2_new=nint(vec_at_new_bnd(3)-norm_dist*basis_at_new_bnd(3)-x_dist*basis_at_new_bnd(6)-y_dist*basis_at_new_bnd(9))
                t2_new=nint(vec_at_new_bnd(1)-norm_dist*norm_at_new_bnd(1))
                x2_new=nint(vec_at_new_bnd(2)-norm_dist*norm_at_new_bnd(2))
                y2_new=nint(vec_at_new_bnd(3)-norm_dist*norm_at_new_bnd(3))




                t2_new_rl=real(t2_new) ; x2_new_rl=real(x2_new); y2_new_rl=real(y2_new)

                ! STEP FROM POINT AT NEW BOUND TO NEW POINT TO COMPLETE PATH VECTOR
                dist2=(norm_dist**2+x_dist**2+y_dist**2)**.5 
                sample_num2=dist2
                if (dist2-sample_num2<=.5) sample_num2=sample_num2-1 ! drop the last sample if it is too close to the end
                nodes2=sample_num2+2 ! total number of nodes including end poi
                path_txy(iz,1)=vec_at_new_bnd(1)             
                path_txy(iz,2)=vec_at_new_bnd(2)
                path_txy(iz,3)=vec_at_new_bnd(3)

                path_t=nint(path_txy(iz,1)) ; path_x=nint(path_txy(iz,2)) ; path_y=nint(path_txy(iz,3))
                !           write(0,*) nint(path_xy(iz,1)),nint(path_xy(iz,2))

if (mask_in(path_t,path_x,path_y)/=1) then
write(0,*) 'mask is odd 1',mask_in(path_t,path_x,path_y),path_t,path_x,path_y
stop
end if

                iz2_rl=0.
                do iz_2=iz+1,nodes
                   iz2_rl=iz2_rl+1.
                   path_txy(iz_2,1)=((t2_new_rl-t2_new_bnd_rl)/dist2)*iz2_rl+t2_new_bnd_rl
                   path_txy(iz_2,2)=((x2_new_rl-x2_new_bnd_rl)/dist2)*iz2_rl+x2_new_bnd_rl
                   path_txy(iz_2,3)=((y2_new_rl-y2_new_bnd_rl)/dist2)*iz2_rl+y2_new_bnd_rl

                   ! IF WE CROSS OUT OF MASK THEN STOP HERE AND GRAB ANOTHER POINT
                   path_t=nint(path_txy(iz_2,1)) ; path_x=nint(path_txy(iz_2,2)) ; path_y=nint(path_txy(iz_2,3))

                   ! IF NEW POINT IS OUTSIDE OF FIGURE BOUNDS, REJECT IT
                   if (path_t<1.or.path_t>nt.or.path_x<1.or.path_x>nx.or.path_y<1.or.path_y>ny) then
                      sample_num=iz_2-2
                      t2=nint(path_txy(iz_2-1,1)) ; x2=nint(path_txy(iz_2-1,2)) ; y2=nint(path_txy(iz_2-1,3))
                      ! cycle loop_n_times
                      exit fillpath   
                      ! IF NEW POINT IS OUTSIDE OF MASK, REJECT IT
                   else if (nint(mask_in(path_t,path_x,path_y))/=1.) then
                      sample_num=iz_2-2
                      t2=nint(path_txy(iz_2-1,1)) ; x2=nint(path_txy(iz_2-1,2)) ; y2=nint(path_txy(iz_2-1,3))
       !               write(0,*) '1', mask_in(t2,x2,y2),iz+1,iz_2,nodes
!stop
            !           cycle loop_n_times
                      exit fillpath
                   else
                      ! COUNT A NEW NODE
                      node_counter=node_counter+1

                   endif

                end do
                t2=path_t ; x2=path_x ; y2=path_y
                if (nint(mask_in(t2,x2,y2))/=1.) then
                   sample_num=sample_num-1
                   t2=nint(path_txy(sample_num-1,1)) ; x2=nint(path_txy(sample_num-1,2)) ; y2=nint(path_txy(sample_num-1,3))
                endif

                exit fillpath

                ! IF CROSSES INNER BOUNDARY
             else if (nint(mask_in(path_t,path_x,path_y))==2.) then
                !           write(0,*) 'mask==2'
                !           stop

                if (ignore_wrapping==1.) then
                   sample_num=iz-2
                   t2=n_t ; x2=n_x ; y2=n_y
                   cycle loop_n_times !
                   ! exit fillpath  !
                end if


                ! GRAB NEAREST BOUNDARY POINT
                if (inner_bnd(n_t,n_x,n_y)/=0) then
                   boundary_index=nint(inner_bnd(n_t,n_x,n_y))
                elseif(inner_bnd(n_t+1,n_x,n_y)/=0.and.n_t+1<=nt) then
                   boundary_index=nint(inner_bnd(n_t+1,n_x,n_y))
                elseif(inner_bnd(n_t-1,n_x,n_y)/=0.and.n_t-1>=1) then
                   boundary_index=nint(inner_bnd(n_t-1,n_x, n_y))
                elseif(inner_bnd(n_t,n_x+1,n_y)/=0.and.n_x+1<=nx) then
                   boundary_index=nint(inner_bnd(n_t,n_x+1,n_y))
                elseif(inner_bnd(n_t,n_x-1,n_y)/=0.and.n_x-1>=1) then
                   boundary_index=nint(inner_bnd(n_t,n_x-1,n_y))
                elseif(inner_bnd(n_t,n_x,n_y+1)/=0.and.n_y+1<=ny) then
                   boundary_index=nint(inner_bnd(n_t,n_x,n_y+1))
                elseif(inner_bnd(n_t,n_x,n_y-1)/=0.and.n_y-1>=1) then
                   boundary_index=nint(inner_bnd(n_t,n_x,n_y-1))
                else
                   write(0,*) 'did not find inner boundary'
             !      stop

                   ! grab another random point  !!! POSSIBLY DELETE
                   sample_num=iz-2              !!! POSSIBLY DELETE
                   t2=n_t ; x2=n_x ; y2=n_y     !!! POSSIBLY DELETE
                   cycle loop_n_times           !!! POSSIBLY DELETE
!!$   sample_num=iz_2-2
!!$                      t2=nint(path_txy(iz_2-1,1)) ; x2=nint(path_txy(iz_2-1,2)) ; y2=nint(path_txy(iz_2-1,2))
!!$  exit fillpath

                end if

                if (boundary_index<1.or.boundary_index>inner_bnd_n1) then
                   write(0,*) 'boundary_index is strange',boundary_index

                   stop
                   ! grab another random point
                   sample_num=iz-2
                   t2=n_t ; x2=n_x ; y2=n_y
                   cycle loop_n_times
                end if

                ! TAKE NORM AND POSITION VECTOR AT NEW BOUNDARY POINT
                !vec_at_new_bnd(1:2)=inner_bnd_tracker(inner_shft1,1:2) 
                t2_new_bnd=inner_bnd_tracker(inner_shft1,1) ! NEW BOUNDARY POINT
                x2_new_bnd=inner_bnd_tracker(inner_shft1,2) ! NEW BOUNDARY POINT
                y2_new_bnd=inner_bnd_tracker(inner_shft1,3) ! NEW BOUNDARY POINT
                t2_new_bnd_rl=real(t2_new_bnd) ; x2_new_bnd_rl=real(x2_new_bnd); y2_new_bnd_rl=real(y2_new_bnd)

                vec_at_bnd=inner_bnd_tracker(boundary_index,1:3)
                vec_at_new_bnd=inner_bnd_tracker(inner_shft1,1:3)
                norm_at_bnd=inner_bnd_tracker(boundary_index,4:6)
                norm_at_new_bnd=inner_bnd_tracker(inner_shft1,4:6)

!!$                basis_at_bnd =inner_bnd_tracker(boundary_index,1:9)
!!$                basis_at_new_bnd=inner_bnd_tracker(inner_shft1,1:9)

                ! VECTOR FROM BOUNDARY TO NEW POINT BEFORE SHIFT
                t2_2bnd=t2-n_t
                x2_2bnd=x2-n_x
                y2_2bnd=y2-n_y
                point2_2bnd(1)=t2_2bnd ; point2_2bnd(2)=x2_2bnd ; point2_2bnd(3)=y2_2bnd

                found1=1

                ! PROJECT ONTO BASIS AS FIRST POINT
                norm_dist   =1.*dot_product(point2_2bnd,basis_at_bnd(1:3))
                in_plane_vec=point2_2bnd-norm_dist*norm_at_bnd
!!$                x_dist      =1.*dot_product(point2_2bnd,basis_at_bnd(4:6))
!!$                y_dist      =1.*dot_product(point2_2bnd,basis_at_bnd(7:9))

                ! PROJECT ON NEW BASIS VECTORS TO GET NEW POINT
!!$                t2_new=nint(vec_at_new_bnd(1)-norm_dist*basis_at_new_bnd(1)-x_dist*basis_at_new_bnd(4)-y_dist*basis_at_new_bnd(7))
!!$                x2_new=nint(vec_at_new_bnd(2)-norm_dist*basis_at_new_bnd(2)-x_dist*basis_at_new_bnd(5)-y_dist*basis_at_new_bnd(8))
!!$                y2_new=nint(vec_at_new_bnd(3)-norm_dist*basis_at_new_bnd(3)-x_dist*basis_at_new_bnd(6)-y_dist*basis_at_new_bnd(9))
                t2_new=nint(vec_at_new_bnd(1)-norm_dist*norm_at_new_bnd(1))
                x2_new=nint(vec_at_new_bnd(2)-norm_dist*norm_at_new_bnd(2))
                y2_new=nint(vec_at_new_bnd(3)-norm_dist*norm_at_new_bnd(3))

                t2_new_rl=real(t2_new) ; x2_new_rl=real(x2_new); y2_new_rl=real(y2_new)

                ! STEP FROM POINT AT NEW BOUND TO NEW POINT TO COMPLETE PATH VECTOR
                dist2=(norm_dist**2+x_dist**2+y_dist**2)**.5 
                sample_num2=dist2
                if (dist2-sample_num2<=.5) sample_num2=sample_num2-1 ! drop the last sample if it is too close to the end
                nodes2=sample_num2+2 ! total number of nodes including end poi
                path_txy(iz,1)=vec_at_new_bnd(1)             
                path_txy(iz,2)=vec_at_new_bnd(2)
                path_txy(iz,3)=vec_at_new_bnd(3)

                path_t=nint(path_txy(iz,1)) ; path_x=nint(path_txy(iz,2)) ; path_y=nint(path_txy(iz,3))
                !           write(0,*) nint(path_xy(iz,1)),nint(path_xy(iz,2))
if (nint(mask_in(path_t,path_x,path_y))/=1) then
write(0,*) 'mask is odd 2'
stop
end if

                iz2_rl=0.
                do iz_2=iz+1,nodes
                   iz2_rl=iz2_rl+1.
                   path_txy(iz_2,1)=((t2_new_rl-t2_new_bnd_rl)/dist2)*iz2_rl+t2_new_bnd_rl
                   path_txy(iz_2,2)=((x2_new_rl-x2_new_bnd_rl)/dist2)*iz2_rl+x2_new_bnd_rl
                   path_txy(iz_2,3)=((y2_new_rl-y2_new_bnd_rl)/dist2)*iz2_rl+y2_new_bnd_rl

                   ! IF WE CROSS OUT OF MASK THEN STOP HERE AND GRAB ANOTHER POINT
                   path_t=nint(path_txy(iz_2,1)) ; path_x=nint(path_txy(iz_2,2)) ; path_y=nint(path_txy(iz_2,3))

                   ! IF NEW POINT IS OUTSIDE OF FIGURE BOUNDS, REJECT IT
                   if (path_t<1.or.path_t>nt.or.path_x<1.or.path_x>nx.or.path_y<1.or.path_y>ny) then
                      sample_num=iz_2-2
                      t2=nint(path_txy(iz_2-1,1)) ; x2=nint(path_txy(iz_2-1,2)) ; y2=nint(path_txy(iz_2-1,3))
                      ! cycle loop_n_times
                      exit fillpath   
                      ! IF NEW POINT IS OUTSIDE OF MASK, REJECT IT
                   else if (nint(mask_in(path_t,path_x,path_y))/=1.) then
                      sample_num=iz_2-2
                      t2=nint(path_txy(iz_2-1,1)) ; x2=nint(path_txy(iz_2-1,2)) ; y2=nint(path_txy(iz_2-1,3))
!            write(0,*) '2', mask_in(t2,x2,y2),iz+1,iz_2,nodes,t2,x2,y2
!stop
 !                    cycle loop_n_times
                      exit fillpath
                   else
                      ! COUNT A NEW NODE
                      node_counter=node_counter+1
                   endif

                end do
                t2=path_t ; x2=path_x ; y2=path_y
                if (nint(mask_in(t2,x2,y2))/=1.) then
                   sample_num=sample_num-1
                   t2=nint(path_txy(sample_num-1,1)) ; x2=nint(path_txy(sample_num-1,2)) ; y2=nint(path_txy(sample_num-1,3))
                endif

                exit fillpath

             end if out_of_mask
             ! IF WITHIN_BNDS AND WITHIN MASK THEN MOVE ON TO NEXT POINT
             n_t=path_t  ! UPDATE LOCATIONS FOR BOUNDARY EXTRACTION
             n_x=path_x
             n_y=path_y
             t2=path_t ; x2=path_x  ; y2=path_y  ! SUSPICIOUS

             ! COUNT A NEW NODE
             node_counter=node_counter+1

          else  ! NOT WITHIN BOUNDS
             !     cycle loop_n_times ! DELETE ME !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
             !stop ! DELETE ME !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
             !write(0,*) 'NOT WITHIN BOUNDS'
             if (iz==2) cycle loop_n_times
             sample_num=sample_num-1
             t2=nint(path_txy(iz-1,1)) ; x2=nint(path_txy(iz-1,2)) ; y2=nint(path_txy(iz-1,3))
             !write(0,*) 'here',t2,x2,y2
             exit fillpath
          end if within_bnds
          !write(0,*) 'here3ab'
       end do fillpath
       !write(0,*) 'after fillpath'
       ! ALLOCATE path_txy TO BE A 2D ARRAY CONTAINING PAIR OF COORDINATES FOR ALL STEPS BETWEEN THE TWO NODES
       ! AND path_dd TO BE THE ARRAY OF POINTS SAMPLED 
       !write(0,*)'nodes/sample_num', nodes, sample_num+2
       nodes=sample_num+2 ! total number of nodes including end points
nodes=node_counter  
     !         write(0,*) 'pathxy',path_xy
       allocate(path_xy(nodes,2))
       path_xy=path_txy(1:nodes,1:2)
       !wt=calc_wt1(nt,nx,path_xy,nodes,full_image_1D,full_image(:,:,1),t1,x1,t2,x2,amp_thresh)
       wt=calc_wt_3d(nt,nx,ny,path_txy,nodes,full_image_1D,full_image,t1,x1,y1,t2,x2,y2,amp_thresh)
!    wt=calc_wt_3d_no_thresh(nt,nx,ny,path_txy,nodes,full_image_1D,full_image,t1,x1,y1,t2,x2,y2,amp_thresh)

       deallocate(path_xy)
       ! APPLY ATTRIBUTE
       !  wt=wt*(.01+.99*exp(-abs((first_attribute(t1,col1)-first_attribute(t2,col2)))/(attr_coef**2))) 
       ! wt=.4*wt+(.6*abs((first_attribute(t1,col1)-first_attribute(t2,col2)))) 

       ! RITE wt TO SPARSE MATRIX IF wt IS GREATER THAN USER DEFINED zero_tol
       if (wt>zero_tol)then


          ! MAKE SURE THIS NEW POINT HAS NOT ALREADY BEEN TESTED WITH THIS BASE POINT
          !write(0,*) 'lookup weight' 
          !   call look_up_wt(look_up_tab,t2,col2,icol_mat)

          icol_mat=look_up_image(t2,x2,y2)
          isnew: if (IsNew(val_list,val_cnt,real(icol_mat))) then
             val_cnt=val_cnt+1 
             val_list(val_cnt)=real(icol_mat) ! if new point, add it to the lis

             sparse_mat_index=sparse_mat_index+1
             if (sparse_mat_index>=mem_alloc) then
                write(0,*) 'did not allocate enough memory'
                stop
             end if
             col_in_row=col_in_row+1  ! a row has been added to this column

             !  call look_up_wt(look_up_tab,t1,col1,irow_mat)
             irow_mat=look_up_image(t1,x1,y1)

             !    call look_up_wt(look_up_tab,t2,col2,icol_mat)
if (icol_mat==0.or.irow_mat==0) then
write(0,*) t1,x1,y1,t2,x2,y2,mask_in(t1,x1,y1),nint(mask_in(t2,x2,y2))
write(0,*) 'icol_mat',icol_mat,'irow_mat',irow_mat
stop
endif
             if (icol_mat>=irow_mat) then
                sparse_mat(sparse_mat_index,1)=irow_mat
                sparse_mat(sparse_mat_index,2)=icol_mat
                sparse_mat(sparse_mat_index,3)=wt
             else
                sparse_mat(sparse_mat_index,1)=icol_mat
                sparse_mat(sparse_mat_index,2)=irow_mat
                sparse_mat(sparse_mat_index,3)=wt
             end if


          end if isnew


       end if
       !   end if within_bnds
       !write(0,*) 'here3'
       deallocate(path_txy)
       !write(0,*) 'here4'
    end do loop_n_times


    !  end if isnew


    deallocate(norm_at_bnd,vec_at_new_bnd,norm_at_new_bnd)
    deallocate(xt_basis,xt_basis_2,yt_basis,yt_basis_2)
    deallocate(basis_at_bnd,basis_at_new_bnd) 




  end subroutine sample_model3d

  real function calc_wt_3d(nt,nx,ny,path_txy,nodes,full_image_1D,full_image,t1,x1,y1,t2,x2,y2,amp_thresh)
    integer                             :: nx,ny,nt,nodes,t1,x1,y1,t2,x2,y2,dt,dx,dy
    integer                             ::t1_back,x1_back,y1_back,t2_back,x2_back,y2_back
    real                                ::amp_thresh,wt
    real, pointer, dimension(:,:)       ::path_txy,new_path_txy
    real,dimension(:)                 	::full_image_1d
    real,dimension(:,:,:)                 ::full_image
    real,pointer, dimension(:)	        ::path_dd 
    integer,pointer,dimension(:)   ::n_lint
    real, pointer, dimension(:)    :: d_lint,o_lint
    real                                ::drow,dcol
    !write(0,*) 'y1/y2',y1,y2

    allocate(new_path_txy(nodes,3),path_dd(nodes))

    allocate(n_lint(3),d_lint(3),o_lint(3))

    n_lint=(/nt,nx,ny/) ; o_lint=(/1.,1.,1./) ; d_lint=1.
    path_dd=0.
    new_path_txy=path_txy(1:nodes,1:)
    !write(0,*) 'new_path_txy',new_path_txy(1:,3)
!!$
!!$    new_path_txy(1:,3)=1.
    !if ((t1==4..and.t2==5).or.(t2==4.and.t1==5)) then
    !write(0,*) 't1/t2/nodes',t1,t2,nodes
    !end if

    !        write(0,*) 'herea'
    ! INITIALIZE BILINEAR INTERPOLATOR
    !call lint2_init(nt,nx,1.,1.,1.,1.,new_path_xy) ! o1=1 is the first model sample
    !    write(0,*) 'initializing interpolator'
  
    !   write(0,*) 'initialized interpolator'
    !  call lint2_init(nt,nx,0.,1.,0.,1.,new_path_xy)
    !write(0,*) 'new_path_xy',new_path_txy(1:,3)
    !write(0,*) 'nodes',nodes
    !path_dd(1)=full_image(t1,col1)
    !path_dd(2)=full_image(t2,col2)
    !        write(0,*) t2,col2,t1,col1,sample_num

    ! IF THE POINTS ARE NOT ADJACENT THEN ASSIGN A WEIGHT HERE
    not_2_nodes1: if(nodes/=2) then
       !           write(0,*) 'hereb'

  call lint_init(n_lint,o_lint,d_lint,new_path_txy)
       ! INTERPOLATE - SAMPLE ALONG THE PATH BETWEEN THE TWO NODES
       ! stat1=lint2_lop(.false.,.false.,full_image_1d,path_dd)
       !   write(0,*) 'calling interpolator'
!full_image_1d=.3
!full_image=.3
     stat1=lint_lop(.false.,.false.,full_image_1d,path_dd)
  call lint_close
       !  write(0,*) 'called interpolator'
       !     write(0,*) path_dd

 !      path_dd(1)    =full_image(t1,x1,y1) ! assign end points
 !      path_dd(nodes)=full_image(t2,x2,y2)


!!$if (t1==nt/2.and.x1==1) then
!!$write(0,*) 'nodes=',nodes
!!$ write(0,*) 'row1,col1',t1,x1
!!$  write(0,*) 'row2,col2',t2,x2
!!$write(0,*) 'xy, for t',new_path_txy(1:,1)
!!$write(0,*) 'xy, for x',new_path_txy(1:,2)
!!$write(0,*) 'xy, for y',new_path_txy(1:,3)
!!$write(0,*) path_dd
!!$write(0,*) 'full',full_image(t2,x2,y2)
!!$!write(0,*) 'full',full_image(9,47,y2)
!!$!stop
!!$end if
       if (minval(path_dd(2:nodes-1))<=path_dd(1).and.minval(path_dd(2:nodes-1))<=path_dd(nodes)&
            .and.minval(path_dd(2:nodes-1))<amp_thresh) then
          wt=0.
       else
          wt=1.

          if (path_dd(1)<amp_thresh.and.path_dd(1)<minval((path_dd(2:nodes)))) then
             ! IF BASE NODE IS A MININUM then break only along north-east
             if (t2>=t1.and.x2>=x1.and.y2>=y1) then ! break only along north-east
!!$  if (t2>=t1) then ! break only along north-east
                wt=0.
             end if

          end if

          if (path_dd(nodes)<amp_thresh.and.path_dd(nodes)<minval((path_dd(1:nodes-1)))) then
             ! IF BASE NODE IS A MININUM then break only along north-east
             if (t2<=t1.and.x2<=x1.and.y2<=y1) then ! break only along north-east
!!$  if (t2<=t1) then ! break only along north-east
                wt=0.
             end if

          end if




       end if

       ! IF THE POINTS ARE ADJACENT THEN ASSIGN A WEIGHT HERE
    else
       !            write(0,*) 'here2'
       path_dd(1)=full_image(t1,x1,y1) ! assign end points
       path_dd(nodes)=full_image(t2,x2,y2)

       if (nodes/=2) then
          write(0,*) 'weird'
          stop
       endif

       wt=1.
       dt=t1-t2
       dx=x1-x2
       dy=y1-y2

       t2_back=t2-dt
       x2_back=x2-dx
       y2_back=y2-dy

       t1_back=t1+dt
       x1_back=x1+dx
       y1_back=y1+dy

       if (t2_back>=1.and.t2_back<=nt.and.x2_back>=1.and.x2_back<=nx.and.y2_back>=1.and.y2_back<=ny) then
          if (full_image(t2_back,x2_back,y2_back)>full_image(t2,x2,y2).and.&
               full_image(t1,x1,y1)>full_image(t2,x2,y2).and.full_image(t2,x2,y2)<amp_thresh) then
             if (t2<=t1.and.x2<=x1.and.y2<=y1) then ! break only along north-east
                wt=0.
             end if
          end if
       end if

       if (t1_back>=1.and.t1_back<=nt.and.x1_back>=1.and.x1_back<=nx.and.y1_back>=1.and.y1_back<=ny) then
          if (full_image(t1_back,x1_back,y1_back)>full_image(t1,x1,y1).and.&
               full_image(t2,x2,y2)>full_image(t1,x1,y1).and.full_image(t1,x1,y1)<amp_thresh) then
             if (t1<=t2.and.x1<=x2.and.y1<=y2) then ! break only along north-east

                wt=0.
             end if
          end if
       end if

       ! IF THE POINT IS ON A BOUNDARY
       if (t2_back<1.OR.t2_back>nt.OR.x2_back<1.OR.x2_back>nx.OR.y2_back<1.OR.y2_back>ny) then
          if (full_image(t1,x1,y1)>full_image(t2,x2,y2).and.full_image(t2,x2,y2)<amp_thresh) then
            if (t2<=t1.and.x2<=x1.and.y2<=y1) then ! break only along north-east  !!!!!!!!!!!!!!!!!!! UNDELETE ME
! if (t2<=t1) then !!!!!!!!!!!!!!!!!!! DELETE ME
                wt=0.
             end if
          end if
       end if

       ! IF THE POINT IS ON A BOUNDARY
       if (t1_back<1.or.t1_back>nt.or.x1_back<1.or.x1_back>nx.or.y1_back<1.or.y1_back>ny) then
          if (full_image(t2,x2,y2)>full_image(t1,x1,y1).and.full_image(t1,x1,y1)<amp_thresh) then
             if (t1<=t2.and.x1<=x2.and.y1<=y2) then ! break only along north-east   !!!!!!!!!!!!!!!!!!! UNDELETE ME
 !   if (t1<=t2) then !!!!!!!!!!!!!!!!!!! DELETE ME
                wt=0.
             end if
          end if
       end if
!!$write(0,*) t1,x1,t2,x2, wt
!!$if (t1==2.and.x1==2.and.t2==3.and.x2==1) wt=0.
!!$if (t2==2.and.x2==2.and.t1==3.and.x1==1) wt=0.
    end if not_2_nodes1
!!$if ((t1==2.and.x1==2.and.t2==3.and.x2==1).or.(t2==2.and.x2==2.and.t1==3.and.x1==1))q then
!!$write(0,*) 't1,nodes'
!!$write(0,*) t1,x1,y1
!!$write(0,*) t1_back,x1_back,y1_back
!!$write(0,*) t2,x2,y2, nodes
!!$write(0,*) t2_back,x2_back,y2_back
!!$do it=1,nodes
!!$write(0,*) new_path_txy(it,1:)
!!$enddo
!!$write(0,*) path_dd
!!$write(0,*) 'wt',wt
!!$
!!$end if
    calc_wt_3d=wt
    deallocate(n_lint,d_lint,o_lint)
    deallocate(new_path_txy,path_dd)
  !  call lint_close
    ! if (size(path_xy)>0) deallocate(path_xy,new_path_xy)
  end function calc_wt_3d


  real function calc_wt_3d_no_thresh(nt,nx,ny,path_txy,nodes,full_image_1D,full_image,t1,x1,y1,t2,x2,y2,amp_thresh)
    integer                             :: nx,ny,nt,nodes,t1,x1,y1,t2,x2,y2,dt,dx,dy
    integer                             ::t1_back,x1_back,y1_back,t2_back,x2_back,y2_back
    real                                ::amp_thresh,wt
    real, pointer, dimension(:,:)       ::path_txy,new_path_txy
    real,dimension(:)                 	::full_image_1d
    real,dimension(:,:,:)                 ::full_image
    real,pointer, dimension(:)	        ::path_dd 
    integer,pointer,dimension(:)   ::n_lint
    real, pointer, dimension(:)    :: d_lint,o_lint
    real                                ::drow,dcol
    !write(0,*) 'y1/y2',y1,y2

    allocate(new_path_txy(nodes,3),path_dd(nodes))

    allocate(n_lint(3),d_lint(3),o_lint(3))

    n_lint=(/nt,nx,ny/) ; o_lint=(/1.,1.,1./) ; d_lint=1.
    path_dd=0.
    new_path_txy=path_txy(1:nodes,1:)
    !write(0,*) 'new_path_txy',new_path_txy(1:,3)
!!$
!!$    new_path_txy(1:,3)=1.
    !if ((t1==4..and.t2==5).or.(t2==4.and.t1==5)) then
    !write(0,*) 't1/t2/nodes',t1,t2,nodes
    !end if

    !        write(0,*) 'herea'
    ! INITIALIZE BILINEAR INTERPOLATOR
    !call lint2_init(nt,nx,1.,1.,1.,1.,new_path_xy) ! o1=1 is the first model sample
    !    write(0,*) 'initializing interpolator'

    !   write(0,*) 'initialized interpolator'
    !  call lint2_init(nt,nx,0.,1.,0.,1.,new_path_xy)
    !write(0,*) 'new_path_xy',new_path_txy(1:,3)
    !write(0,*) 'nodes',nodes
    !path_dd(1)=full_image(t1,col1)
    !path_dd(2)=full_image(t2,col2)
    !        write(0,*) t2,col2,t1,col1,sample_num

    ! IF THE POINTS ARE NOT ADJACENT THEN ASSIGN A WEIGHT HERE
    not_2_nodes1: if(nodes/=2) then
       !           write(0,*) 'hereb'

       call lint_init(n_lint,o_lint,d_lint,new_path_txy)
       ! INTERPOLATE - SAMPLE ALONG THE PATH BETWEEN THE TWO NODES
       ! stat1=lint2_lop(.false.,.false.,full_image_1d,path_dd)
       !   write(0,*) 'calling interpolator'
       !full_image_1d=.3
       !full_image=.3
       stat1=lint_lop(.false.,.false.,full_image_1d,path_dd)
       call lint_close
       !  write(0,*) 'called interpolator'
       !     write(0,*) path_dd

       !      path_dd(1)    =full_image(t1,x1,y1) ! assign end points
       !      path_dd(nodes)=full_image(t2,x2,y2)


!!$if (t1==nt/2.and.x1==1) then
!!$write(0,*) 'nodes=',nodes
!!$ write(0,*) 'row1,col1',t1,x1
!!$  write(0,*) 'row2,col2',t2,x2
!!$write(0,*) 'xy, for t',new_path_txy(1:,1)
!!$write(0,*) 'xy, for x',new_path_txy(1:,2)
!!$write(0,*) 'xy, for y',new_path_txy(1:,3)
!!$write(0,*) path_dd
!!$write(0,*) 'full',full_image(t2,x2,y2)
!!$!write(0,*) 'full',full_image(9,47,y2)
!!$!stop
!!$end if
       if (minval(path_dd(2:nodes-1))<=path_dd(1).and.minval(path_dd(2:nodes-1))<=path_dd(nodes)&
            .and.minval(path_dd(2:nodes-1))<amp_thresh) then
          !wt=0.
wt=minval(path_dd(2:nodes-1))
       else
          wt=1.


          if (path_dd(1)<amp_thresh.and.path_dd(1)<minval((path_dd(2:nodes)))) then
             ! IF BASE NODE IS A MININUM then break only along north-east
             if (t2>=t1.and.x2>=x1.and.y2>=y1) then ! break only along north-east
!!$  if (t2>=t1) then ! break only along north-east
                wt=0.
wt=minval((path_dd(2:nodes)))
             end if

          end if

          if (path_dd(nodes)<amp_thresh.and.path_dd(nodes)<minval((path_dd(1:nodes-1)))) then
             ! IF BASE NODE IS A MININUM then break only along north-east
             if (t2<=t1.and.x2<=x1.and.y2<=y1) then ! break only along north-east
!!$  if (t2<=t1) then ! break only along north-east
                wt=0.
wt=minval((path_dd(1:nodes-1)))
             end if

          end if




       end if

       ! IF THE POINTS ARE ADJACENT THEN ASSIGN A WEIGHT HERE
    else
       !            write(0,*) 'here2'
       path_dd(1)=full_image(t1,x1,y1) ! assign end points
       path_dd(nodes)=full_image(t2,x2,y2)

       if (nodes/=2) then
          write(0,*) 'weird'
          stop
       endif

       wt=1.
       dt=t1-t2
       dx=x1-x2
       dy=y1-y2

       t2_back=t2-dt
       x2_back=x2-dx
       y2_back=y2-dy

       t1_back=t1+dt
       x1_back=x1+dx
       y1_back=y1+dy

       if (t2_back>=1.and.t2_back<=nt.and.x2_back>=1.and.x2_back<=nx.and.y2_back>=1.and.y2_back<=ny) then
          if (full_image(t2_back,x2_back,y2_back)>full_image(t2,x2,y2).and.&
               full_image(t1,x1,y1)>full_image(t2,x2,y2).and.full_image(t2,x2,y2)<amp_thresh) then
             if (t2<=t1.and.x2<=x1.and.y2<=y1) then ! break only along north-east
                wt=0.
             end if
          end if
       end if

       if (t1_back>=1.and.t1_back<=nt.and.x1_back>=1.and.x1_back<=nx.and.y1_back>=1.and.y1_back<=ny) then
          if (full_image(t1_back,x1_back,y1_back)>full_image(t1,x1,y1).and.&
               full_image(t2,x2,y2)>full_image(t1,x1,y1).and.full_image(t1,x1,y1)<amp_thresh) then
             if (t1<=t2.and.x1<=x2.and.y1<=y2) then ! break only along north-east

                wt=0.
             end if
          end if
       end if

       ! IF THE POINT IS ON A BOUNDARY
       if (t2_back<1.OR.t2_back>nt.OR.x2_back<1.OR.x2_back>nx.OR.y2_back<1.OR.y2_back>ny) then
          if (full_image(t1,x1,y1)>full_image(t2,x2,y2).and.full_image(t2,x2,y2)<amp_thresh) then
             if (t2<=t1.and.x2<=x1.and.y2<=y1) then ! break only along north-east  !!!!!!!!!!!!!!!!!!! UNDELETE ME
                ! if (t2<=t1) then !!!!!!!!!!!!!!!!!!! DELETE ME
                wt=0.
             end if
          end if
       end if

       ! IF THE POINT IS ON A BOUNDARY
       if (t1_back<1.or.t1_back>nt.or.x1_back<1.or.x1_back>nx.or.y1_back<1.or.y1_back>ny) then
          if (full_image(t2,x2,y2)>full_image(t1,x1,y1).and.full_image(t1,x1,y1)<amp_thresh) then
             if (t1<=t2.and.x1<=x2.and.y1<=y2) then ! break only along north-east   !!!!!!!!!!!!!!!!!!! UNDELETE ME
                !   if (t1<=t2) then !!!!!!!!!!!!!!!!!!! DELETE ME
                wt=0.
             end if
          end if
       end if
!!$write(0,*) t1,x1,t2,x2, wt
!!$if (t1==2.and.x1==2.and.t2==3.and.x2==1) wt=0.
!!$if (t2==2.and.x2==2.and.t1==3.and.x1==1) wt=0.
    end if not_2_nodes1
!!$if ((t1==2.and.x1==2.and.t2==3.and.x2==1).or.(t2==2.and.x2==2.and.t1==3.and.x1==1))q then
!!$write(0,*) 't1,nodes'
!!$write(0,*) t1,x1,y1
!!$write(0,*) t1_back,x1_back,y1_back
!!$write(0,*) t2,x2,y2, nodes
!!$write(0,*) t2_back,x2_back,y2_back
!!$do it=1,nodes
!!$write(0,*) new_path_txy(it,1:)
!!$enddo
!!$write(0,*) path_dd
!!$write(0,*) 'wt',wt
!!$
!!$end if
    calc_wt_3d_no_thresh=wt
    deallocate(n_lint,d_lint,o_lint)
    deallocate(new_path_txy,path_dd)
    !  call lint_close
    ! if (size(path_xy)>0) deallocate(path_xy,new_path_xy)
  end function calc_wt_3d_no_thresh


  real function calc_wt1(nt,nx,path_xy,nodes,full_image_1D,full_image,row1,col1,row2,col2,amp_thresh)
    integer                             :: nx,ny,nt,nodes,row1,col1,row2,col2
    real                                ::amp_thresh,wt
    real, pointer, dimension(:,:)       ::path_xy,new_path_xy
    real,dimension(:)                 	::full_image_1d
    real,dimension(:,:)                 ::full_image
    real,dimension(:),allocatable	::path_dd 
    real                                ::drow,dcol
    integer                             ::row2_back,row1_back,col2_back,col1_back

    allocate(new_path_xy(nodes,2),path_dd(nodes))
    path_dd=0.
    new_path_xy=path_xy(1:nodes,1:)
    !        write(0,*) 'herea'
    ! INITIALIZE BILINEAR INTERPOLATOR
    call lint2_init(nt,nx,1.,1.,1.,1.,new_path_xy) ! o1=1 is the first model sample
    !  call lint2_init(nt,nx,0.,1.,0.,1.,new_path_xy)

    !path_dd(1)=full_image(row1,col1)
    !path_dd(2)=full_image(row2,col2)
    !        write(0,*) row2,col2,row1,col1,sample_num

    ! IF THE POINTS ARE NOT ADJACENT THEN ASSIGN A WEIGHT HERE
    not_2_nodes1: if(nodes/=2) then
       !           write(0,*) 'hereb'


       ! INTERPOLATE - SAMPLE ALONG THE PATH BETWEEN THE TWO NODES
       stat1=lint2_lop(.false.,.false.,full_image_1d,path_dd)
!!$

       path_dd(1)=full_image(row1,col1) ! assign end points
       path_dd(nodes)=full_image(row2,col2)
!!$if (row1==nt.and.col1==1) then
!!$   write(0,*) 'row2,col2',row2,col2
!!$write(0,*) path_dd
!!$!stop
!!$end if
       if (minval(path_dd(2:nodes-1))<=path_dd(1).and.minval(path_dd(2:nodes-1))<=path_dd(nodes)&
            .and.minval(path_dd(2:nodes-1))<amp_thresh) then
          wt=0.
       else
          wt=1.

          if (path_dd(1)<amp_thresh.and.path_dd(1)<minval((path_dd(2:nodes)))) then
             ! IF BASE NODE IS A MININUM then break only along north-east
             if (row2>=row1.and.col2>=col1) then ! break only along north-east
!!$  if (row2>=row1) then ! break only along north-east
                wt=0.
             end if

          end if

          if (path_dd(nodes)<amp_thresh.and.path_dd(nodes)<minval((path_dd(1:nodes-1)))) then
             ! IF BASE NODE IS A MININUM then break only along north-east
             if (row2<=row1.and.col2<=col1) then ! break only along north-east
!!$  if (row2<=row1) then ! break only along north-east
                wt=0.
             end if

          end if




       end if

       ! IF THE POINTS ARE ADJACENT THEN ASSIGN A WEIGHT HERE
    else
       !            write(0,*) 'here2'
       path_dd(1)=full_image(row1,col1) ! assign end points
       path_dd(nodes)=full_image(row2,col2)

       if (nodes/=2) then
          write(0,*) 'weird'
          stop
       endif

       wt=1.
       drow=row1-row2
       dcol=col1-col2
       row2_back=row2-drow
       col2_back=col2-dcol

       row1_back=row1+drow
       col1_back=col1+dcol

       if (row2_back>=1.and.row2_back<=nt.and.col2_back>=1.and.col2_back<=nx) then
          if (full_image(row2_back,col2_back)>full_image(row2,col2).and.&
               full_image(row1,col1)>full_image(row2,col2).and.full_image(row2,col2)<amp_thresh) then
             if (row2<=row1.and.col2<=col1) then ! break only along north-east
!!$         if (row2<=row1) then ! break only along north-east
                wt=0.
             end if
          end if
       end if

       if (row1_back>=1.and.row1_back<=nt.and.col1_back>=1.and.col1_back<=nx) then
          if (full_image(row1_back,col1_back)>full_image(row1,col1).and.&
               full_image(row2,col2)>full_image(row1,col1).and.full_image(row1,col1)<amp_thresh) then
             if (row1<=row2.and.col1<=col2) then ! break only along north-east
!!$    if (row1<=row2) then ! break only along north-east
                wt=0.
             end if
          end if
       end if

       ! IF THE POINT IS ON A BOUNDARY
       if (row2_back<1.OR.row2_back>nt.OR.col2_back<1.OR.col2_back>nx) then
          if (full_image(row1,col1)>full_image(row2,col2).and.full_image(row2,col2)<amp_thresh) then
             if (row2<=row1.and.col2<=col1) then ! break only along north-east
!!$   if (row2<=row1) then ! break only along north-east
                wt=0.
             end if
          end if
       end if

       ! IF THE POINT IS ON A BOUNDARY
       if (row1_back<1.or.row1_back>nt.or.col1_back<1.or.col1_back>nx) then
          if (full_image(row2,col2)>full_image(row1,col1).and.full_image(row1,col1)<amp_thresh) then
             if (row1<=row2.and.col1<=col2) then ! break only along north-east
!!$  if (row1<=row2) then ! break only along north-east
                wt=0.
             end if
          end if
       end if



    end if not_2_nodes1
    calc_wt1=wt
    deallocate(path_dd)
    deallocate(new_path_xy)
    ! if (size(path_xy)>0) deallocate(path_xy,new_path_xy)
  end function calc_wt1

 
  real function calc_wt2(nt,nx,path_xy,nodes,full_image_1D,full_image,t1,col1,t2,col2,amp_thresh)
    integer                             :: nx,ny,nt,nodes,t1,col1,t2,col2
    real                                ::amp_thresh,wt
    real, pointer, dimension(:,:)       ::path_xy,new_path_xy
    real,dimension(:)                 	::full_image_1d
    real,dimension(:,:)                 ::full_image
    real,dimension(:),allocatable	::path_dd 
    real                                ::drow,dcol
    integer                             ::t2_back,t1_back,col2_back,col1_back

    allocate(new_path_xy(nodes,2),path_dd(nodes))
    path_dd=0.
    new_path_xy=path_xy(1:nodes,1:)
    !        write(0,*) 'herea'
    ! INITIALIZE BILINEAR INTERPOLATOR
    call lint2_init(nt,nx,1.,1.,1.,1.,new_path_xy) ! o1=1 is the first model sample
    !  call lint2_init(nt,nx,0.,1.,0.,1.,new_path_xy)

    !path_dd(1)=full_image(t1,col1)
    !path_dd(2)=full_image(t2,col2)
    !        write(0,*) t2,col2,t1,col1,sample_num

    ! IF THE POINTS ARE NOT ADJACENT THEN ASSIGN A WEIGHT HERE
    not_2_nodes1: if(nodes/=2) then
       !           write(0,*) 'hereb'


       ! INTERPOLATE - SAMPLE ALONG THE PATH BETWEEN THE TWO NODES
       stat1=lint2_lop(.false.,.false.,full_image_1d,path_dd)
       path_dd(1)=full_image(t1,col1) ! assign end points
       path_dd(nodes)=full_image(t2,col2)

       if (minval(path_dd(2:nodes-1))<=path_dd(1).and.minval(path_dd(2:nodes-1))<=path_dd(nodes)&
            .and.minval(path_dd(2:nodes-1))<amp_thresh) then
          wt=0.
          !wt=minval(path_dd(2:nodes-1))
       else
          wt=1.
          !wt=minval(path_dd(2:nodes-1))
          !write(0,*) wt
          if (path_dd(1)<amp_thresh.and.path_dd(1)<minval((path_dd(2:nodes)))) then
             ! IF BASE NODE IS A MININUM then break only along north-east
             if (t2>=t1.and.col2>=col1) then ! break only along north-east
!!$  if (t2>=t1) then ! break only along north-east
                wt=0.
                !wt=minval(path_dd(2:nodes-1))
             end if

          end if

          if (path_dd(nodes)<amp_thresh.and.path_dd(nodes)<minval((path_dd(1:nodes-1)))) then
             ! IF BASE NODE IS A MININUM then break only along north-east
             if (t2<=t1.and.col2<=col1) then ! break only along north-east
!!$  if (t2<=t1) then ! break only along north-east
                wt=0.
                ! wt=minval(path_dd(2:nodes-1))
             end if

          end if




       end if
       !wt=minval(path_dd(2:nodes-1))
       ! IF THE POINTS ARE ADJACENT THEN ASSIGN A WEIGHT HERE
    else
       !            write(0,*) 'here2'
       path_dd(1)=full_image(t1,col1) ! assign end points
       path_dd(nodes)=full_image(t2,col2)

       if (nodes/=2) then
          write(0,*) 'weird'
          stop
       endif

       wt=1.
       drow=t1-t2
       dcol=col1-col2
       t2_back=t2-drow
       col2_back=col2-dcol

       t1_back=t1+drow
       col1_back=col1+dcol

       if (t2_back>=1.and.t2_back<=nt.and.col2_back>=1.and.col2_back<=nx) then
          if (full_image(t2_back,col2_back)>full_image(t2,col2).and.&
               full_image(t1,col1)>full_image(t2,col2).and.full_image(t2,col2)<amp_thresh) then
             if (t2<=t1.and.col2<=col1) then ! break only along north-east
!!$         if (t2<=t1) then ! break only along north-east
                wt=0.
             end if
          end if
       end if

       if (t1_back>=1.and.t1_back<=nt.and.col1_back>=1.and.col1_back<=nx) then
          if (full_image(t1_back,col1_back)>full_image(t1,col1).and.&
               full_image(t2,col2)>full_image(t1,col1).and.full_image(t1,col1)<amp_thresh) then
             if (t1<=t2.and.col1<=col2) then ! break only along north-east
!!$    if (t1<=t2) then ! break only along north-east
                wt=0.
             end if
          end if
       end if

       ! IF THE POINT IS ON A BOUNDARY
       if (t2_back<1.OR.t2_back>nt.OR.col2_back<1.OR.col2_back>nx) then
          if (full_image(t1,col1)>full_image(t2,col2).and.full_image(t2,col2)<amp_thresh) then
             if (t2<=t1.and.col2<=col1) then ! break only along north-east
!!$   if (t2<=t1) then ! break only along north-east
                wt=0.
             end if
          end if
       end if

       ! IF THE POINT IS ON A BOUNDARY
       if (t1_back<1.or.t1_back>nt.or.col1_back<1.or.col1_back>nx) then
          if (full_image(t2,col2)>full_image(t1,col1).and.full_image(t1,col1)<amp_thresh) then
             if (t1<=t2.and.col1<=col2) then ! break only along north-east
!!$  if (t1<=t2) then ! break only along north-east
                wt=0.
             end if
          end if
       end if



    end if not_2_nodes1
    calc_wt2=wt
    deallocate(path_dd)
    deallocate(new_path_xy)
    ! if (size(path_xy)>0) deallocate(path_xy,new_path_xy)
  end function calc_wt2

  subroutine sample_model3d_sub(nt,nx,ny,j1,j2,j3,mem_alloc,sample_scale,max_dist,amp_thresh,zero_tol,t1,x1,y1,full_image,full_image_1d,sparse_mat,sparse_mat_index,col_in_row,look_up_image,val_list,val_cnt,mask_in,outer_bnd,outer_bnd_tracker,inner_bnd,inner_bnd_tracker,first_attribute,attr_coef,ignore_wrapping)


    real,dimension(:)	                ::val_list
    integer                             ::val_cnt,sample_num,iz
    integer                             ::sparse_mat_index,mem_alloc,irow_mat,icol_mat
    integer                             ::nodes,path_t,path_x,path_y,node_counter
    integer                             ::t_shift_int,x_shift_int,y_shift_int,j1,j2,j3
    real,dimension(:)                 	::full_image_1d
    real, pointer, dimension(:,:)       ::sparse_mat,path_txy,new_path_txy,path_xy
    real,dimension(:),allocatable	::path_dd,in_plane_vec
    real, dimension(:,:,:)                ::look_up_image,first_attribute
    real                                ::t1_rl,t2_rl,x1_rl,y1_rl,x2_rl,y2_rl,iz_rl,sample_scale
    real                                ::x_shift,y_shift,rand_dip,rand_dir,rand_azi,rand_dist,dist,pi_var,dist2,amp_thresh
    real                                ::attr_coef,in_plane_dist
    integer                             ::t2_closest,x2_closest,y2_closest
    integer                             ::it,ix,iy,boundary_index,iq
    integer                             :: nx,ny,nt,max_dist,t1,col1,rand_jump_int
    integer                             ::t2_raw,x2_raw,y2_raw,delta_t2,delta_x2,delta_y2
    integer                             ::t2,x2,y2,too_far,dumbtest,found1
    integer                             ::col_in_row,x1,y1
    integer                             ::n_t,n_x,n_y,outer_shft1,outer_bnd_sum,inner_shft1
    integer                             ::inner_bnd_sum,step,n_t2,n_x2,n_y2,irow
    integer                             ::outer_bnd_n1, inner_bnd_n1,ignore_wrapping
    real                                ::rand_jump,vec_length,norm_length
    real                                ::dt,dx,dy,norm_dist1,xt_dist,yt_dist 
    real                                ::t2_2bnd,x2_2bnd,y2_2bnd
    real,dimension(:),allocatable	::norm_at_bnd,norm_at_new_bnd  !,t2_2bnd
    real,dimension(:),allocatable       ::xt_basis,xt_basis_2,yt_basis,yt_basis_2
    real,dimension(:),allocatable       ::basis_at_bnd,basis_at_new_bnd,point2_2bnd
    real,dimension(:),allocatable       ::vec_at_bnd,vec_at_new_bnd
    real,pointer, dimension(:,:,:)      ::full_image
    real,dimension(:,:)                 ::inner_bnd_tracker,outer_bnd_tracker  
    real, dimension(:,:,:)                ::mask_in
    real, dimension(:,:,:)                ::inner_bnd,outer_bnd

!!$write(0,*) mask_in(12,116,62)
!!$write(0,*) nt,nx,ny
!!$stop

!!$do it=1,nt
!!$do ix=1,nx
!!$do iy=1,ny
!!$!if (mask_in(it,ix,iy)==0.or. mask_in(it,ix,iy)==1.or.mask_in(it,ix,iy)==2)  then
!!$if (mask_in(it,ix,iy)>1..and.mask_in(it,ix,iy)<1.1)then
!!$!else
!!$write(0,*) mask_in(it,ix,iy), it,ix,iy
!!$end if
!!$end do
!!$end do
!!$end do
!!$write(0,*) 'stopping'
!!$stop

!!$
!!$  call to_history("n1",nt,"test.H"); call to_history("n2",nx,"test.H") 
!!$  call to_history("n3",ny,"test.H")
!!$ 
!!$  call sep_write(mask_in,"test.H")
!!$ stop


    !       write(0,*) 'into sample subroutine'
    pi_var=acos(-1.)
!!$    y1=1 ! DELETE ME !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    t1_rl=real(t1)
    x1_rl=real(x1)
    y1_rl=real(y1)

    ! call look_up_wt(look_up_tab,t1,col1,irow_mat)

    outer_bnd_n1=size(outer_bnd_tracker(1:,1))
    inner_bnd_n1=size(inner_bnd_tracker(1:,1))
!!$write(0,*) 'outer_bnd_n1',outer_bnd_n1
!!$write(0,*) 'inner_bnd_n1',inner_bnd_n1
    ! CONVENTIONS outer_bnd_tracker AND inner_bnd_tracker CONTAIN THE BASIS VECTORS
    ! *_bnd_tracker(1:3) ==> the norm 
    ! *_bnd_tracker(4:6) ==> the tangent in x direction 
    ! *_bnd_tracker(7:9) ==> the tangent in y direction

    ! RENORMALIZE BASIS VECTORS
!!$    do iq=1,outer_bnd_n1
!!$       outer_bnd_tracker(iq,3:4)=outer_bnd_tracker(iq,3:4)/((outer_bnd_tracker(iq,3)**2+outer_bnd_tracker(iq,4)**2)**.5)
!!$       outer_bnd_tracker(iq,5:6)=outer_bnd_tracker(iq,5:6)/((outer_bnd_tracker(iq,5)**2+outer_bnd_tracker(iq,6)**2)**.5)  
!!$    end do
!!$    do iq=1,inner_bnd_n1
!!$       inner_bnd_tracker(iq,3:4)=inner_bnd_tracker(iq,3:4)/((inner_bnd_tracker(iq,3)**2+inner_bnd_tracker(iq,4)**2)**.5)
!!$       inner_bnd_tracker(iq,5:6)=inner_bnd_tracker(iq,5:6)/((inner_bnd_tracker(iq,5)**2+inner_bnd_tracker(iq,6)**2)**.5)  
!!$    end do

    allocate(norm_at_bnd(3),norm_at_new_bnd(3)) !,t2_2bnd(3))
    allocate(xt_basis(3),xt_basis_2(3),yt_basis(3),yt_basis_2(3))
    allocate(basis_at_bnd(9),basis_at_new_bnd(9))
    allocate(vec_at_bnd(3),vec_at_new_bnd(3),in_plane_vec(3))

    allocate(point2_2bnd(3))
    !write(0,*) 'after allocations'



    ! DRAW RANDOM BOUNDARY SHIFTS
    ! JUMP RANDOM SHIFTS WHEN ABOVE OR BELOW MASK BOUNDARY
!!$    call random_number(rand_jump)
!!$    outer_shft1=nint(rand_jump*real(outer_bnd_n1-1)+1)   
!!$    inner_shft1=nint(rand_jump*real(inner_bnd_n1-1)+1)





    ! CALCULATE NUMBER OF SAMPLES
    n_sam=nint(sample_scale*(3.*pi_var*real(max_dist))) 
   ! write(0,*) 'nsam',n_sam
   ! stop


    loop_n_times: do srch=1,n_sam

       ! KEEP TRACK OF HOW MANY PIXELS (NODES)
       node_counter=1

       ! DRAW RANDOM NUMBERS  ==> DISTANCE, AZIMUTH
       ! DRAW RAND DIRECTION
       call random_number (rand_dip)
       rand_dip=rand_dip*2.*pi_var ! assign angle
       call random_number (rand_azi)
       rand_azi=rand_azi*2.*pi_var ! assign angle
!!$       rand_azi=0. ! DELETE ME !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
       ! DRAW RAND DISTANCE
       call random_number(rand_dist)
       rand_dist=(max_dist-1)*rand_dist+1


       ! DRAW RANDOM BOUNDARY SHIFTS
       ! JUMP RANDOM SHIFTS WHEN ABOVE OR BELOW MASK BOUNDARY
       call random_number(rand_jump)
       outer_shft1=nint(rand_jump*real(outer_bnd_n1-1)+1)   
       inner_shft1=nint(rand_jump*real(inner_bnd_n1-1)+1)


       ! CALCULATE SHIFTS FROM SPHERICAL COORDINATES
       t_shift=rand_dist*sin(rand_dip)
       x_shift=rand_dist*cos(rand_dip)*cos(rand_azi)
       y_shift=rand_dist*cos(rand_dip)*sin(rand_azi)


!!$       call random_number (rand_dir)! DELETE ME !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!$       rand_dir=rand_dir*2.*pi_var ! assign angle! DELETE ME !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!$       t_shift=rand_dist*cos(rand_dir) ! DELETE ME !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!$       x_shift=rand_dist*sin(rand_dir) ! DELETE ME !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!$       y_shift=0. ! DELETE ME !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

       t_shift_int=nint(t_shift)
       x_shift_int=nint(x_shift)
       y_shift_int=nint(y_shift)
       !write(0,*) t_shift_int ,x_shift_int, y_shift_int


       ! OLD WAY  
       t2=t1+t_shift_int
       x2=x1+x_shift_int
       y2=y1+y_shift_int


       t2_rl=real(t2)
       x2_rl=real(x2)
       y2_rl=real(y2)



!!$       ! LOCATE CLOSEST SUBSAMPLED POINT
       t2_rl=real(t1)+t_shift
       x2_rl=real(x1)+x_shift
       y2_rl=real(y1)+y_shift
!!$
!!$       ! MAKE SURE NEW POINT IS WITHIN BOUNDS
!!$       ! IF NOT, THEN GRAB A NEW POINT
    
       t2_closest=(floor(1.5 + ((t2_rl-1.)/real(j1)))-1)*j1+1
       x2_closest=(floor(1.5 + ((x2_rl-1.)/real(j2)))-1)*j2+1
       y2_closest=(floor(1.5 + ((y2_rl-1.)/real(j3)))-1)*j3+1


  if (t2_rl<1..or.t2_rl>real(nt).or.x2_rl<1.or.x2_rl>real(nx).or.y2_rl<1.or.y2_rl>real(ny) )  cycle loop_n_times 
  if (t2_closest<1..or.t2_closest>real(nt).or.x2_closest<1.or.x2_closest>real(nx).or.y2_closest<1.or.y2_closest>real(ny) )  cycle loop_n_times  
!!$write(0,*) 't2',t2,t2_closest
!!$write(0,*) 'x2',x2,x2_closest
!!$write(0,*) 'y2',y2,y2_closest




       t2=t2_closest
       x2=x2_closest
       y2=y2_closest

       t2_rl=real(t2_closest)
       x2_rl=real(x2_closest)
       y2_rl=real(y2_closest)





       dist=sqrt((t1_rl-t2_rl)**2+(x1_rl-x2_rl)**2+(y1_rl-y2_rl)**2)


!!$       if (t1==nt.and.x1==1.) then
!!$          write(0,*) t1,x1,t2,x2
!!$          write(0,*) 'dist',dist
!!$
!!$       end if
       ! MAKE SURE THE NEW POINT IS IN THE DATA CUBE
       !    within_bnds:  if (t2>=1.and.t2<=nt.and.col2>=1.and.col2<=nx ) then


       !          write(0,*) 'here1'
       !   call look_up_wt(look_up_tab,t2,col2,icol_mat)    
       !         write(0,*) 'here2'

!!$          ! MAKE SURE THIS NEW POINT HAS NOT ALREADY BEEN TESTED WITH THIS BASE POINT
!!$          isnew: if (IsNew(val_list,val_cnt,real(icol_mat))) then
!!$             val_cnt=val_cnt+1 
!!$             val_list(val_cnt)=real(icol_mat) ! if new point, add it to the list


       ! START STEPPING TOWARDS THE NEW POINT, KEEPING TRACK OF X,Y'S FOR BILINEAR INTERPOLATION AND ALSO CHECK TO SEE IF A BOUNDARY IS CROSSED

       sample_num=dist ! round down the distance(dist) to get the number of samples between points
       if (dist-sample_num<=.5) sample_num=sample_num-1 ! drop the last sample if it is too close to the end
       nodes=sample_num+2 ! total number of nodes including end points
!!$       if (t1==nt.and.x1==1.) then
!!$          write(0,*) 'sample_num',sample_num
!!$          write(0,*) 'nodes',nodes
!!$       end if
       !write(0,*) 'here1'
       allocate(path_txy(nodes,3))
       !write(0,*) 'here2',nodes

       path_txy(1,1)=t1_rl; path_txy(1,2)=x1_rl; path_txy(1,3)=y1_rl

       n_t=t1  ! ASSIGN LOCATIONS FOR BOUNDARY EXTRACTION
       n_x=x1
       n_y=y1

       !if (nodes==2) node_counter=2

       !         write(0,*) 'nodes at beginning',nodes
       ! ASSIGN XY PAIRS TO EACH SAMPLE
       fillpath: do iz=2,nodes
          !write(0,*) iz,nodes
          !write(0,*) 'here 2ba'
          iz_rl=real(iz)
          !       path_xy(iz,1)=((t2_rl-t1_rl)/dist)*(iz_rl-1)+t1_rl
          !       path_xy(iz,2)=((col2_rl-col1_rl)/dist)*(iz_rl-1)+col1_rl
          path_txy(iz,1)=((t2_rl-t1_rl)/(nodes-1))*(iz_rl-1.)+t1_rl
          path_txy(iz,2)=((x2_rl-x1_rl)/(nodes-1))*(iz_rl-1.)+x1_rl
          path_txy(iz,3)=((y2_rl-y1_rl)/(nodes-1))*(iz_rl-1.)+y1_rl
          ! write(0,*) 'path_txy(iz,3)',path_txy(iz,3)
          path_t=nint(path_txy(iz,1)) ; path_x=nint(path_txy(iz,2)) ; path_y=nint(path_txy(iz,3))

          !write(0,*) 'here 2bb',path_t,nt,path_x,nx,path_y,ny

!!$          if (t1==nt.and.x1==1.) then
!!$             write(0,*) 'iz',iz
!!$             write(0,*) path_txy(iz,1),path_txy(iz,2),path_txy(iz,3)
!!$             write(0,*) 'path_t,path_x,path_y',path_t,path_x,path_y
!!$          end if

          within_bnds:  if (path_txy(iz,1)>=1.and.path_txy(iz,1)<=nt.and.path_txy(iz,2)>=1.and.path_txy(iz,2)<=nx.and.path_txy(iz,3)>=1.and.path_txy(iz,3)<=ny ) then



             !write(0,*) path_row,path_col
             !write(0,*) 'here 2b'
             ! CHECK TO SEE IF BOUNDARY IS CROSSED
             ! IF CROSSES OUTER BOUNDARY
             out_of_mask: if (nint(mask_in(path_t,path_x,path_y))==0) then
                             write(0,*) 'mask==0'
                  stop
                if (ignore_wrapping==1.) then
                   sample_num=iz-2
                   t2=n_t ;x2=n_x ; y2=n_y
                   cycle loop_n_times !
                   ! exit fillpath !
                end if

                !            write(0,*) 'here2a'
                ! GRAB NEAREST BOUNDARY POINT
                if (outer_bnd(n_t,n_x,n_y)/=0) then
                   boundary_index=nint(outer_bnd(n_t,n_x,n_y))
                elseif(outer_bnd(n_t+1,n_x,n_y)/=0.and.n_t+1<=nt) then
                   boundary_index=nint(outer_bnd(n_t+1,n_x,n_y))
                elseif(outer_bnd(n_t-1,n_x,n_y)/=0.and.n_t-1>=1) then
                   boundary_index=nint(outer_bnd(n_t-1,n_x, n_y))
                elseif(outer_bnd(n_t,n_x+1,n_y)/=0.and.n_x+1<=nx) then
                   boundary_index=nint(outer_bnd(n_t,n_x+1,n_y))
                elseif(outer_bnd(n_t,n_x-1,n_y)/=0.and.n_x-1>=1) then
                   boundary_index=nint(outer_bnd(n_t,n_x-1,n_y))
                elseif(outer_bnd(n_t,n_x,n_y+1)/=0.and.n_y+1<=ny) then
                   boundary_index=nint(outer_bnd(n_t,n_x,n_y+1))
                elseif(outer_bnd(n_t,n_x,n_y-1)/=0.and.n_y-1>=1) then
                   boundary_index=nint(outer_bnd(n_t,n_x,n_y-1))
                else
                   write(0,*) 'did not find outer boundary',n_t,n_x,n_y,outer_bnd(n_t,n_x,n_y)
                   ! stop
                   ! grab another random point  !!! POSSIBLY DELETE
                   sample_num=iz-2              !!! POSSIBLY DELETE
                   t2=n_t ; x2=n_x ; y2=n_y     !!! POSSIBLY DELETE
                   cycle loop_n_times           !!! POSSIBLY DELETE


                end if

                if (boundary_index<1.or.boundary_index>outer_bnd_n1) then
                   write(0,*) 'boundary_index is strange',boundary_index
                   stop
                end if

                ! TAKE NORM AND POSITION VECTOR AT NEW BOUNDARY POINT
                !vec_at_new_bnd(1:2)=outer_bnd_tracker(outer_shft1,1:3) 
                t2_new_bnd=outer_bnd_tracker(outer_shft1,1) ! NEW BOUNDARY POINT
                x2_new_bnd=outer_bnd_tracker(outer_shft1,2) ! NEW BOUNDARY POINT
                y2_new_bnd=outer_bnd_tracker(outer_shft1,3) ! NEW BOUNDARY POINT
                t2_new_bnd_rl=real(t2_new_bnd) ; x2_new_bnd_rl=real(x2_new_bnd); y2_new_bnd_rl=real(y2_new_bnd)

                vec_at_bnd=outer_bnd_tracker(boundary_index,1:3)
                vec_at_new_bnd=outer_bnd_tracker(outer_shft1,1:3)
                norm_at_bnd=outer_bnd_tracker(boundary_index,4:6)
                norm_at_new_bnd=outer_bnd_tracker(outer_shft1,4:6)
!!$                basis_at_bnd =outer_bnd_tracker(boundary_index,1:9)
!!$                basis_at_new_bnd=outer_bnd_tracker(outer_shft1,1:9)

                ! VECTOR FROM BOUNDARY TO NEW POINT BEFORE SHIFT
                t2_2bnd=t2-n_t
                x2_2bnd=x2-n_x
                y2_2bnd=y2-n_y
                point2_2bnd(1)=t2_2bnd ; point2_2bnd(2)=x2_2bnd ; point2_2bnd(3)=y2_2bnd

                found1=1

                ! PROJECT ONTO BASIS AS FIRST POINT
                norm_dist   =1.*dot_product(point2_2bnd,norm_at_bnd)
                in_plane_vec=point2_2bnd-norm_dist*norm_at_bnd
                !         norm_dist   =1.*dot_product(point2_2bnd,basis_at_bnd(1:3))
                !         x_dist      =1.*dot_product(point2_2bnd,basis_at_bnd(4:6))
                !         y_dist      =1.*dot_product(point2_2bnd,basis_at_bnd(7:9))

                ! PROJECT ON NEW BASIS VECTORS TO GET NEW POINT
!!$                t2_new=nint(vec_at_new_bnd(1)-norm_dist*basis_at_new_bnd(1)-x_dist*basis_at_new_bnd(4)-y_dist*basis_at_new_bnd(7))
!!$                x2_new=nint(vec_at_new_bnd(2)-norm_dist*basis_at_new_bnd(2)-x_dist*basis_at_new_bnd(5)-y_dist*basis_at_new_bnd(8))
!!$                y2_new=nint(vec_at_new_bnd(3)-norm_dist*basis_at_new_bnd(3)-x_dist*basis_at_new_bnd(6)-y_dist*basis_at_new_bnd(9))
                t2_new=nint(vec_at_new_bnd(1)-norm_dist*norm_at_new_bnd(1))
                x2_new=nint(vec_at_new_bnd(2)-norm_dist*norm_at_new_bnd(2))
                y2_new=nint(vec_at_new_bnd(3)-norm_dist*norm_at_new_bnd(3))




                t2_new_rl=real(t2_new) ; x2_new_rl=real(x2_new); y2_new_rl=real(y2_new)

                ! STEP FROM POINT AT NEW BOUND TO NEW POINT TO COMPLETE PATH VECTOR
                dist2=(norm_dist**2+x_dist**2+y_dist**2)**.5 
                sample_num2=dist2
                if (dist2-sample_num2<=.5) sample_num2=sample_num2-1 ! drop the last sample if it is too close to the end
                nodes2=sample_num2+2 ! total number of nodes including end poi
                path_txy(iz,1)=vec_at_new_bnd(1)             
                path_txy(iz,2)=vec_at_new_bnd(2)
                path_txy(iz,3)=vec_at_new_bnd(3)

                path_t=nint(path_txy(iz,1)) ; path_x=nint(path_txy(iz,2)) ; path_y=nint(path_txy(iz,3))
                !           write(0,*) nint(path_xy(iz,1)),nint(path_xy(iz,2))

                if (mask_in(path_t,path_x,path_y)/=1) then
                   write(0,*) 'mask is odd 1',mask_in(path_t,path_x,path_y),path_t,path_x,path_y
                   stop
                end if

                iz2_rl=0.
                do iz_2=iz+1,nodes
                   iz2_rl=iz2_rl+1.
                   path_txy(iz_2,1)=((t2_new_rl-t2_new_bnd_rl)/dist2)*iz2_rl+t2_new_bnd_rl
                   path_txy(iz_2,2)=((x2_new_rl-x2_new_bnd_rl)/dist2)*iz2_rl+x2_new_bnd_rl
                   path_txy(iz_2,3)=((y2_new_rl-y2_new_bnd_rl)/dist2)*iz2_rl+y2_new_bnd_rl

                   ! IF WE CROSS OUT OF MASK THEN STOP HERE AND GRAB ANOTHER POINT
                   path_t=nint(path_txy(iz_2,1)) ; path_x=nint(path_txy(iz_2,2)) ; path_y=nint(path_txy(iz_2,3))

                   ! IF NEW POINT IS OUTSIDE OF FIGURE BOUNDS, REJECT IT
                   if (path_t<1.or.path_t>nt.or.path_x<1.or.path_x>nx.or.path_y<1.or.path_y>ny) then
                      sample_num=iz_2-2
                      t2=nint(path_txy(iz_2-1,1)) ; x2=nint(path_txy(iz_2-1,2)) ; y2=nint(path_txy(iz_2-1,3))
                      ! cycle loop_n_times
                      exit fillpath   
                      ! IF NEW POINT IS OUTSIDE OF MASK, REJECT IT
                   else if (nint(mask_in(path_t,path_x,path_y))/=1.) then
                      sample_num=iz_2-2
                      t2=nint(path_txy(iz_2-1,1)) ; x2=nint(path_txy(iz_2-1,2)) ; y2=nint(path_txy(iz_2-1,3))
                      !               write(0,*) '1', mask_in(t2,x2,y2),iz+1,iz_2,nodes
                      !stop
                      !           cycle loop_n_times
                      exit fillpath
                   else
                      ! COUNT A NEW NODE
                      node_counter=node_counter+1

                   endif

                end do
                t2=path_t ; x2=path_x ; y2=path_y
                if (nint(mask_in(t2,x2,y2))/=1.) then
                   sample_num=sample_num-1
                   t2=nint(path_txy(sample_num-1,1)) ; x2=nint(path_txy(sample_num-1,2)) ; y2=nint(path_txy(sample_num-1,3))
                endif

                exit fillpath

                ! IF CROSSES INNER BOUNDARY
             else if (nint(mask_in(path_t,path_x,path_y))==2.) then
                          write(0,*) 'mask==2'
                           stop

                if (ignore_wrapping==1.) then
                   sample_num=iz-2
                   t2=n_t ; x2=n_x ; y2=n_y
                   cycle loop_n_times !
                   ! exit fillpath  !
                end if


                ! GRAB NEAREST BOUNDARY POINT
                if (inner_bnd(n_t,n_x,n_y)/=0) then
                   boundary_index=nint(inner_bnd(n_t,n_x,n_y))
                elseif(inner_bnd(n_t+1,n_x,n_y)/=0.and.n_t+1<=nt) then
                   boundary_index=nint(inner_bnd(n_t+1,n_x,n_y))
                elseif(inner_bnd(n_t-1,n_x,n_y)/=0.and.n_t-1>=1) then
                   boundary_index=nint(inner_bnd(n_t-1,n_x, n_y))
                elseif(inner_bnd(n_t,n_x+1,n_y)/=0.and.n_x+1<=nx) then
                   boundary_index=nint(inner_bnd(n_t,n_x+1,n_y))
                elseif(inner_bnd(n_t,n_x-1,n_y)/=0.and.n_x-1>=1) then
                   boundary_index=nint(inner_bnd(n_t,n_x-1,n_y))
                elseif(inner_bnd(n_t,n_x,n_y+1)/=0.and.n_y+1<=ny) then
                   boundary_index=nint(inner_bnd(n_t,n_x,n_y+1))
                elseif(inner_bnd(n_t,n_x,n_y-1)/=0.and.n_y-1>=1) then
                   boundary_index=nint(inner_bnd(n_t,n_x,n_y-1))
                else
                   write(0,*) 'did not find inner boundary'
                   !      stop

                   ! grab another random point  !!! POSSIBLY DELETE
                   sample_num=iz-2              !!! POSSIBLY DELETE
                   t2=n_t ; x2=n_x ; y2=n_y     !!! POSSIBLY DELETE
                   cycle loop_n_times           !!! POSSIBLY DELETE
!!$   sample_num=iz_2-2
!!$                      t2=nint(path_txy(iz_2-1,1)) ; x2=nint(path_txy(iz_2-1,2)) ; y2=nint(path_txy(iz_2-1,2))
!!$  exit fillpath

                end if

                if (boundary_index<1.or.boundary_index>inner_bnd_n1) then
                   write(0,*) 'boundary_index is strange',boundary_index

                   stop
                   ! grab another random point
                   sample_num=iz-2
                   t2=n_t ; x2=n_x ; y2=n_y
                   cycle loop_n_times
                end if

                ! TAKE NORM AND POSITION VECTOR AT NEW BOUNDARY POINT
                !vec_at_new_bnd(1:2)=inner_bnd_tracker(inner_shft1,1:2) 
                t2_new_bnd=inner_bnd_tracker(inner_shft1,1) ! NEW BOUNDARY POINT
                x2_new_bnd=inner_bnd_tracker(inner_shft1,2) ! NEW BOUNDARY POINT
                y2_new_bnd=inner_bnd_tracker(inner_shft1,3) ! NEW BOUNDARY POINT
                t2_new_bnd_rl=real(t2_new_bnd) ; x2_new_bnd_rl=real(x2_new_bnd); y2_new_bnd_rl=real(y2_new_bnd)

                vec_at_bnd=inner_bnd_tracker(boundary_index,1:3)
                vec_at_new_bnd=inner_bnd_tracker(inner_shft1,1:3)
                norm_at_bnd=inner_bnd_tracker(boundary_index,4:6)
                norm_at_new_bnd=inner_bnd_tracker(inner_shft1,4:6)

!!$                basis_at_bnd =inner_bnd_tracker(boundary_index,1:9)
!!$                basis_at_new_bnd=inner_bnd_tracker(inner_shft1,1:9)

                ! VECTOR FROM BOUNDARY TO NEW POINT BEFORE SHIFT
                t2_2bnd=t2-n_t
                x2_2bnd=x2-n_x
                y2_2bnd=y2-n_y
                point2_2bnd(1)=t2_2bnd ; point2_2bnd(2)=x2_2bnd ; point2_2bnd(3)=y2_2bnd

                found1=1

                ! PROJECT ONTO BASIS AS FIRST POINT
                norm_dist   =1.*dot_product(point2_2bnd,basis_at_bnd(1:3))
                in_plane_vec=point2_2bnd-norm_dist*norm_at_bnd
!!$                x_dist      =1.*dot_product(point2_2bnd,basis_at_bnd(4:6))
!!$                y_dist      =1.*dot_product(point2_2bnd,basis_at_bnd(7:9))

                ! PROJECT ON NEW BASIS VECTORS TO GET NEW POINT
!!$                t2_new=nint(vec_at_new_bnd(1)-norm_dist*basis_at_new_bnd(1)-x_dist*basis_at_new_bnd(4)-y_dist*basis_at_new_bnd(7))
!!$                x2_new=nint(vec_at_new_bnd(2)-norm_dist*basis_at_new_bnd(2)-x_dist*basis_at_new_bnd(5)-y_dist*basis_at_new_bnd(8))
!!$                y2_new=nint(vec_at_new_bnd(3)-norm_dist*basis_at_new_bnd(3)-x_dist*basis_at_new_bnd(6)-y_dist*basis_at_new_bnd(9))
                t2_new=nint(vec_at_new_bnd(1)-norm_dist*norm_at_new_bnd(1))
                x2_new=nint(vec_at_new_bnd(2)-norm_dist*norm_at_new_bnd(2))
                y2_new=nint(vec_at_new_bnd(3)-norm_dist*norm_at_new_bnd(3))

                t2_new_rl=real(t2_new) ; x2_new_rl=real(x2_new); y2_new_rl=real(y2_new)

                ! STEP FROM POINT AT NEW BOUND TO NEW POINT TO COMPLETE PATH VECTOR
                dist2=(norm_dist**2+x_dist**2+y_dist**2)**.5 
                sample_num2=dist2
                if (dist2-sample_num2<=.5) sample_num2=sample_num2-1 ! drop the last sample if it is too close to the end
                nodes2=sample_num2+2 ! total number of nodes including end poi
                path_txy(iz,1)=vec_at_new_bnd(1)             
                path_txy(iz,2)=vec_at_new_bnd(2)
                path_txy(iz,3)=vec_at_new_bnd(3)

                path_t=nint(path_txy(iz,1)) ; path_x=nint(path_txy(iz,2)) ; path_y=nint(path_txy(iz,3))
                !           write(0,*) nint(path_xy(iz,1)),nint(path_xy(iz,2))
                if (nint(mask_in(path_t,path_x,path_y))/=1) then
                   write(0,*) 'mask is odd 2'
                   stop
                end if

                iz2_rl=0.
                do iz_2=iz+1,nodes
                   iz2_rl=iz2_rl+1.
                   path_txy(iz_2,1)=((t2_new_rl-t2_new_bnd_rl)/dist2)*iz2_rl+t2_new_bnd_rl
                   path_txy(iz_2,2)=((x2_new_rl-x2_new_bnd_rl)/dist2)*iz2_rl+x2_new_bnd_rl
                   path_txy(iz_2,3)=((y2_new_rl-y2_new_bnd_rl)/dist2)*iz2_rl+y2_new_bnd_rl

                   ! IF WE CROSS OUT OF MASK THEN STOP HERE AND GRAB ANOTHER POINT
                   path_t=nint(path_txy(iz_2,1)) ; path_x=nint(path_txy(iz_2,2)) ; path_y=nint(path_txy(iz_2,3))

                   ! IF NEW POINT IS OUTSIDE OF FIGURE BOUNDS, REJECT IT
                   if (path_t<1.or.path_t>nt.or.path_x<1.or.path_x>nx.or.path_y<1.or.path_y>ny) then
                      sample_num=iz_2-2
                      t2=nint(path_txy(iz_2-1,1)) ; x2=nint(path_txy(iz_2-1,2)) ; y2=nint(path_txy(iz_2-1,3))
                      ! cycle loop_n_times
                      exit fillpath   
                      ! IF NEW POINT IS OUTSIDE OF MASK, REJECT IT
                   else if (nint(mask_in(path_t,path_x,path_y))/=1.) then
                      sample_num=iz_2-2
                      t2=nint(path_txy(iz_2-1,1)) ; x2=nint(path_txy(iz_2-1,2)) ; y2=nint(path_txy(iz_2-1,3))
                      !            write(0,*) '2', mask_in(t2,x2,y2),iz+1,iz_2,nodes,t2,x2,y2
                      !stop
                      !                    cycle loop_n_times
                      exit fillpath
                   else
                      ! COUNT A NEW NODE
                      node_counter=node_counter+1
                   endif

                end do
                t2=path_t ; x2=path_x ; y2=path_y
                if (nint(mask_in(t2,x2,y2))/=1.) then
                   sample_num=sample_num-1
                   t2=nint(path_txy(sample_num-1,1)) ; x2=nint(path_txy(sample_num-1,2)) ; y2=nint(path_txy(sample_num-1,3))
                endif

                exit fillpath

             end if out_of_mask
             ! IF WITHIN_BNDS AND WITHIN MASK THEN MOVE ON TO NEXT POINT
             n_t=path_t  ! UPDATE LOCATIONS FOR BOUNDARY EXTRACTION
             n_x=path_x
             n_y=path_y
             t2=path_t ; x2=path_x  ; y2=path_y  ! SUSPICIOUS

             ! COUNT A NEW NODE
             node_counter=node_counter+1

          else  ! NOT WITHIN BOUNDS
             !     cycle loop_n_times ! DELETE ME !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
             !stop ! DELETE ME !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
             !write(0,*) 'NOT WITHIN BOUNDS'
             if (iz==2) cycle loop_n_times
             sample_num=sample_num-1
             t2=nint(path_txy(iz-1,1)) ; x2=nint(path_txy(iz-1,2)) ; y2=nint(path_txy(iz-1,3))
             !write(0,*) 'here',t2,x2,y2
             exit fillpath
          end if within_bnds
          !write(0,*) 'here3ab'
       end do fillpath
       !write(0,*) 'after fillpath'
       ! ALLOCATE path_txy TO BE A 2D ARRAY CONTAINING PAIR OF COORDINATES FOR ALL STEPS BETWEEN THE TWO NODES
       ! AND path_dd TO BE THE ARRAY OF POINTS SAMPLED 
       !write(0,*)'nodes/sample_num', nodes, sample_num+2
       nodes=sample_num+2 ! total number of nodes including end points
       nodes=node_counter  
       !         write(0,*) 'pathxy',path_xy
       allocate(path_xy(nodes,2))
       path_xy=path_txy(1:nodes,1:2)
       !wt=calc_wt1(nt,nx,path_xy,nodes,full_image_1D,full_image(:,:,1),t1,x1,t2,x2,amp_thresh)
       wt=calc_wt_3d(nt,nx,ny,path_txy,nodes,full_image_1D,full_image,t1,x1,y1,t2,x2,y2,amp_thresh)
       deallocate(path_xy)
       ! APPLY ATTRIBUTE
       !  wt=wt*(.01+.99*exp(-abs((first_attribute(t1,col1)-first_attribute(t2,col2)))/(attr_coef**2))) 
       ! wt=.4*wt+(.6*abs((first_attribute(t1,col1)-first_attribute(t2,col2)))) 

       ! RITE wt TO SPARSE MATRIX IF wt IS GREATER THAN USER DEFINED zero_tol
       if (wt>zero_tol)then


          ! MAKE SURE THIS NEW POINT HAS NOT ALREADY BEEN TESTED WITH THIS BASE POINT
          !write(0,*) 'lookup weight' 
          !   call look_up_wt(look_up_tab,t2,col2,icol_mat)

          icol_mat=look_up_image(t2,x2,y2)
          isnew: if (IsNew(val_list,val_cnt,real(icol_mat))) then
             val_cnt=val_cnt+1 
             val_list(val_cnt)=real(icol_mat) ! if new point, add it to the lis

             sparse_mat_index=sparse_mat_index+1
             if (sparse_mat_index>=mem_alloc) then
                write(0,*) 'did not allocate enough memory'
                stop
             end if
             col_in_row=col_in_row+1  ! a row has been added to this column

             !  call look_up_wt(look_up_tab,t1,col1,irow_mat)
             irow_mat=look_up_image(t1,x1,y1)

             !    call look_up_wt(look_up_tab,t2,col2,icol_mat)
             if (icol_mat==0.or.irow_mat==0) then
                write(0,*) t1,x1,y1,t2,x2,y2,mask_in(t1,x1,y1),nint(mask_in(t2,x2,y2))
                write(0,*) 'icol_mat',icol_mat,'irow_mat',irow_mat
                stop
             endif
             if (icol_mat>=irow_mat) then
                sparse_mat(sparse_mat_index,1)=irow_mat
                sparse_mat(sparse_mat_index,2)=icol_mat
                sparse_mat(sparse_mat_index,3)=wt
             else
                sparse_mat(sparse_mat_index,1)=icol_mat
                sparse_mat(sparse_mat_index,2)=irow_mat
                sparse_mat(sparse_mat_index,3)=wt
             end if


          end if isnew


       end if
       !   end if within_bnds
       !write(0,*) 'here3'
       deallocate(path_txy)
       !write(0,*) 'here4'
    end do loop_n_times


    !  end if isnew


    deallocate(norm_at_bnd,vec_at_new_bnd,norm_at_new_bnd)
    deallocate(xt_basis,xt_basis_2,yt_basis,yt_basis_2)
    deallocate(basis_at_bnd,basis_at_new_bnd) 




  end subroutine sample_model3d_sub



end module sample_mod_3d
